require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETISDN_I4B_IOCTL_H_)) {
    eval 'sub _NETISDN_I4B_IOCTL_H_ () {1;}' unless defined(&_NETISDN_I4B_IOCTL_H_);
    if(defined(&__FreeBSD__)  && (defined(&__FreeBSD__) ? &__FreeBSD__ : undef) >= 3) {
	unless(defined(&_MACHINE_TYPES_H_)) {
	    require 'machine/types.ph';
	}
    }
    require 'sys/ioccom.ph';
    eval 'sub VERSION () {0;}' unless defined(&VERSION);
    eval 'sub REL () {96;}' unless defined(&REL);
    eval 'sub STEP () {00;}' unless defined(&STEP);
    eval 'sub I4B_TIME_FORMAT () {"%d.%m.%Y %H:%M:%S";}' unless defined(&I4B_TIME_FORMAT);
    eval 'sub PROTOCOL_DSS1 () {0;}' unless defined(&PROTOCOL_DSS1);
    eval 'sub PROTOCOL_D64S () {1;}' unless defined(&PROTOCOL_D64S);
    eval 'sub TELNO_MAX () {41;}' unless defined(&TELNO_MAX);
    eval 'sub SUBADDR_MAX () {22;}' unless defined(&SUBADDR_MAX);
    eval 'sub DISPLAY_MAX () {91;}' unless defined(&DISPLAY_MAX);
    eval 'sub DATETIME_MAX () {21;}' unless defined(&DATETIME_MAX);
    eval 'sub TELNO_EMPTY () {"NotAvailable";}' unless defined(&TELNO_EMPTY);
    eval 'sub BCH_MAX_DATALEN () {2048;}' unless defined(&BCH_MAX_DATALEN);
    eval 'sub BPROT_NONE () {0;}' unless defined(&BPROT_NONE);
    eval 'sub BPROT_RHDLC () {1;}' unless defined(&BPROT_RHDLC);
    eval 'sub CDID_UNUSED () {0;}' unless defined(&CDID_UNUSED);
    eval 'sub CDID_MAX () {99999;}' unless defined(&CDID_MAX);
    eval 'sub SHA_FIXU () {0;}' unless defined(&SHA_FIXU);
    eval 'sub SHA_VARU () {1;}' unless defined(&SHA_VARU);
    eval 'sub MSG_CONNECT_IND () {ord(\'a\');}' unless defined(&MSG_CONNECT_IND);
    eval 'sub MSG_CONNECT_ACTIVE_IND () {ord(\'b\');}' unless defined(&MSG_CONNECT_ACTIVE_IND);
    eval 'sub MSG_DISCONNECT_IND () {ord(\'c\');}' unless defined(&MSG_DISCONNECT_IND);
    eval 'sub MSG_DIALOUT_IND () {ord(\'d\');}' unless defined(&MSG_DIALOUT_IND);
    eval 'sub MSG_IDLE_TIMEOUT_IND () {ord(\'e\');}' unless defined(&MSG_IDLE_TIMEOUT_IND);
    eval 'sub MSG_ACCT_IND () {ord(\'f\');}' unless defined(&MSG_ACCT_IND);
    eval 'sub MSG_CHARGING_IND () {ord(\'g\');}' unless defined(&MSG_CHARGING_IND);
    eval 'sub MSG_PROCEEDING_IND () {ord(\'h\');}' unless defined(&MSG_PROCEEDING_IND);
    eval 'sub MSG_ALERT_IND () {ord(\'i\');}' unless defined(&MSG_ALERT_IND);
    eval 'sub MSG_DRVRDISC_REQ () {ord(\'j\');}' unless defined(&MSG_DRVRDISC_REQ);
    eval 'sub MSG_L12STAT_IND () {ord(\'k\');}' unless defined(&MSG_L12STAT_IND);
    eval 'sub MSG_TEIASG_IND () {ord(\'l\');}' unless defined(&MSG_TEIASG_IND);
    eval 'sub MSG_PDEACT_IND () {ord(\'m\');}' unless defined(&MSG_PDEACT_IND);
    eval 'sub MSG_NEGCOMP_IND () {ord(\'n\');}' unless defined(&MSG_NEGCOMP_IND);
    eval 'sub MSG_IFSTATE_CHANGED_IND () {ord(\'o\');}' unless defined(&MSG_IFSTATE_CHANGED_IND);
    eval 'sub MSG_DIALOUTNUMBER_IND () {ord(\'p\');}' unless defined(&MSG_DIALOUTNUMBER_IND);
    eval 'sub MSG_PACKET_IND () {ord(\'q\');}' unless defined(&MSG_PACKET_IND);
    eval 'sub MSG_CONTR_EV_IND () {ord(\'r\');}' unless defined(&MSG_CONTR_EV_IND);
    eval 'sub CHAN_B1 () {0;}' unless defined(&CHAN_B1);
    eval 'sub CHAN_B2 () {1;}' unless defined(&CHAN_B2);
    eval 'sub CHAN_ANY () {(-1);}' unless defined(&CHAN_ANY);
    eval 'sub CHAN_NO () {(-2);}' unless defined(&CHAN_NO);
    eval 'sub SCR_NONE () {0;}' unless defined(&SCR_NONE);
    eval 'sub SCR_USR_NOSC () {1;}' unless defined(&SCR_USR_NOSC);
    eval 'sub SCR_USR_PASS () {2;}' unless defined(&SCR_USR_PASS);
    eval 'sub SCR_USR_FAIL () {3;}' unless defined(&SCR_USR_FAIL);
    eval 'sub SCR_NET () {4;}' unless defined(&SCR_NET);
    eval 'sub PRS_NONE () {0;}' unless defined(&PRS_NONE);
    eval 'sub PRS_ALLOWED () {1;}' unless defined(&PRS_ALLOWED);
    eval 'sub PRS_RESTRICT () {2;}' unless defined(&PRS_RESTRICT);
    eval 'sub PRS_NNINTERW () {3;}' unless defined(&PRS_NNINTERW);
    eval 'sub PRS_RESERVED () {4;}' unless defined(&PRS_RESERVED);
    eval 'sub ACCT_DURING () {0;}' unless defined(&ACCT_DURING);
    eval 'sub ACCT_FINAL () {1;}' unless defined(&ACCT_FINAL);
    eval 'sub CHARGE_INVALID () {0;}' unless defined(&CHARGE_INVALID);
    eval 'sub CHARGE_AOCD () {1;}' unless defined(&CHARGE_AOCD);
    eval 'sub CHARGE_AOCE () {2;}' unless defined(&CHARGE_AOCE);
    eval 'sub CHARGE_CALC () {3;}' unless defined(&CHARGE_CALC);
    eval 'sub DIRECTION_IN () {0;}' unless defined(&DIRECTION_IN);
    eval 'sub DIRECTION_OUT () {1;}' unless defined(&DIRECTION_OUT);
    eval 'sub MAX_PACKET_LOG () {40;}' unless defined(&MAX_PACKET_LOG);
    eval 'sub LAYER_ONE () {1;}' unless defined(&LAYER_ONE);
    eval 'sub LAYER_TWO () {2;}' unless defined(&LAYER_TWO);
    eval 'sub LAYER_IDLE () {0;}' unless defined(&LAYER_IDLE);
    eval 'sub LAYER_ACTIVE () {1;}' unless defined(&LAYER_ACTIVE);
    eval 'sub CTRL_EV_IND_DETACH () {0;}' unless defined(&CTRL_EV_IND_DETACH);
    eval 'sub CTRL_EV_IND_ATTACH () {1;}' unless defined(&CTRL_EV_IND_ATTACH);
    eval 'sub I4B_CDID_REQ () { &_IOWR(ord(\'4\'), 0, \'int\');}' unless defined(&I4B_CDID_REQ);
    eval 'sub ULEN_METHOD_STATIC () {0;}' unless defined(&ULEN_METHOD_STATIC);
    eval 'sub ULEN_METHOD_DYNAMIC () {1;}' unless defined(&ULEN_METHOD_DYNAMIC);
    eval 'sub I4B_CONNECT_REQ () { &_IOW(ord(\'4\'), 1,  &msg_connect_req_t);}' unless defined(&I4B_CONNECT_REQ);
    eval 'sub SETUP_RESP_DNTCRE () {0;}' unless defined(&SETUP_RESP_DNTCRE);
    eval 'sub SETUP_RESP_REJECT () {1;}' unless defined(&SETUP_RESP_REJECT);
    eval 'sub SETUP_RESP_ACCEPT () {2;}' unless defined(&SETUP_RESP_ACCEPT);
    eval 'sub I4B_CONNECT_RESP () { &_IOW(ord(\'4\'), 2,  &msg_connect_resp_t);}' unless defined(&I4B_CONNECT_RESP);
    eval 'sub I4B_DISCONNECT_REQ () { &_IOW(ord(\'4\'), 3,  &msg_discon_req_t);}' unless defined(&I4B_DISCONNECT_REQ);
    eval 'sub I4B_CTRL_INFO_REQ () { &_IOWR(ord(\'4\'), 4,  &msg_ctrl_info_req_t);}' unless defined(&I4B_CTRL_INFO_REQ);
    eval 'sub DSTAT_NONE () {0;}' unless defined(&DSTAT_NONE);
    eval 'sub DSTAT_TFAIL () {1;}' unless defined(&DSTAT_TFAIL);
    eval 'sub DSTAT_PFAIL () {2;}' unless defined(&DSTAT_PFAIL);
    eval 'sub DSTAT_INONLY () {3;}' unless defined(&DSTAT_INONLY);
    eval 'sub I4B_DIALOUT_RESP () { &_IOW(ord(\'4\'), 5,  &msg_dialout_resp_t);}' unless defined(&I4B_DIALOUT_RESP);
    eval 'sub I4B_TIMEOUT_UPD () { &_IOW(ord(\'4\'), 6,  &msg_timeout_upd_t);}' unless defined(&I4B_TIMEOUT_UPD);
    eval 'sub SOFT_ENA () {0;}' unless defined(&SOFT_ENA);
    eval 'sub SOFT_DIS () {1;}' unless defined(&SOFT_DIS);
    eval 'sub I4B_UPDOWN_IND () { &_IOW(ord(\'4\'), 7,  &msg_updown_ind_t);}' unless defined(&I4B_UPDOWN_IND);
    eval 'sub I4B_ALERT_REQ () { &_IOW(ord(\'4\'), 8,  &msg_alert_req_t);}' unless defined(&I4B_ALERT_REQ);
    eval 'sub I4B_VR_REQ () { &_IOR(ord(\'4\'), 9,  &msg_vr_req_t);}' unless defined(&I4B_VR_REQ);
    eval 'sub I4B_PROT_IND () { &_IOW(ord(\'4\'), 10,  &msg_prot_ind_t);}' unless defined(&I4B_PROT_IND);
    eval 'sub L4DRIVER_NAME_SIZ () {16;}' unless defined(&L4DRIVER_NAME_SIZ);
    eval 'sub I4B_L4DRIVER_LOOKUP () { &_IOWR(ord(\'4\'), 11,  &msg_l4driver_lookup_t);}' unless defined(&I4B_L4DRIVER_LOOKUP);
    eval 'sub I4B_CTRL_DOWNLOAD () { &_IOW(ord(\'4\'), 100, \'struct isdn_download_request\');}' unless defined(&I4B_CTRL_DOWNLOAD);
    eval 'sub I4B_ACTIVE_DIAGNOSTIC_MAXPARAMLEN () {65536;}' unless defined(&I4B_ACTIVE_DIAGNOSTIC_MAXPARAMLEN);
    eval 'sub I4B_ACTIVE_DIAGNOSTIC () { &_IOW(ord(\'4\'), 102, \'struct isdn_diagnostic_request\');}' unless defined(&I4B_ACTIVE_DIAGNOSTIC);
}
1;
