require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub CR0_PE () {0x1;}' unless defined(&CR0_PE);
eval 'sub CR0_MP () {0x2;}' unless defined(&CR0_MP);
eval 'sub CR0_EM () {0x4;}' unless defined(&CR0_EM);
eval 'sub CR0_TS () {0x8;}' unless defined(&CR0_TS);
eval 'sub CR0_ET () {0x10;}' unless defined(&CR0_ET);
eval 'sub CR0_PG () {0x80000000;}' unless defined(&CR0_PG);
eval 'sub CR0_NE () {0x20;}' unless defined(&CR0_NE);
eval 'sub CR0_WP () {0x10000;}' unless defined(&CR0_WP);
eval 'sub CR0_AM () {0x40000;}' unless defined(&CR0_AM);
eval 'sub CR0_NW () {0x20000000;}' unless defined(&CR0_NW);
eval 'sub CR0_CD () {0x40000000;}' unless defined(&CR0_CD);
eval 'sub CCR0 () {0xc0;}' unless defined(&CCR0);
eval 'sub CCR0_NC0 () {0x1;}' unless defined(&CCR0_NC0);
eval 'sub CCR0_NC1 () {0x2;}' unless defined(&CCR0_NC1);
eval 'sub CCR0_A20M () {0x4;}' unless defined(&CCR0_A20M);
eval 'sub CCR0_KEN () {0x8;}' unless defined(&CCR0_KEN);
eval 'sub CCR0_FLUSH () {0x10;}' unless defined(&CCR0_FLUSH);
eval 'sub CCR0_BARB () {0x20;}' unless defined(&CCR0_BARB);
eval 'sub CCR0_CO () {0x40;}' unless defined(&CCR0_CO);
eval 'sub CCR0_SUSPEND () {0x80;}' unless defined(&CCR0_SUSPEND);
eval 'sub CCR1 () {0xc1;}' unless defined(&CCR1);
eval 'sub CCR1_RPL () {0x1;}' unless defined(&CCR1_RPL);
eval 'sub CR4_VME () {0x1;}' unless defined(&CR4_VME);
eval 'sub CR4_PVI () {0x2;}' unless defined(&CR4_PVI);
eval 'sub CR4_TSD () {0x4;}' unless defined(&CR4_TSD);
eval 'sub CR4_DE () {0x8;}' unless defined(&CR4_DE);
eval 'sub CR4_PSE () {0x10;}' unless defined(&CR4_PSE);
eval 'sub CR4_PAE () {0x20;}' unless defined(&CR4_PAE);
eval 'sub CR4_MCE () {0x40;}' unless defined(&CR4_MCE);
eval 'sub CR4_PGE () {0x80;}' unless defined(&CR4_PGE);
eval 'sub CR4_PCE () {0x100;}' unless defined(&CR4_PCE);
eval 'sub CR4_OSFXSR () {0x200;}' unless defined(&CR4_OSFXSR);
eval 'sub CR4_OSXMMEXCPT () {0x400;}' unless defined(&CR4_OSXMMEXCPT);
eval 'sub CR4_UMIP () {0x800;}' unless defined(&CR4_UMIP);
eval 'sub CR4_VMXE () {0x2000;}' unless defined(&CR4_VMXE);
eval 'sub CR4_SMXE () {0x4000;}' unless defined(&CR4_SMXE);
eval 'sub CR4_FSGSBASE () {0x10000;}' unless defined(&CR4_FSGSBASE);
eval 'sub CR4_PCIDE () {0x20000;}' unless defined(&CR4_PCIDE);
eval 'sub CR4_OSXSAVE () {0x40000;}' unless defined(&CR4_OSXSAVE);
eval 'sub CR4_SMEP () {0x100000;}' unless defined(&CR4_SMEP);
eval 'sub CR4_SMAP () {0x200000;}' unless defined(&CR4_SMAP);
eval 'sub CR4_PKE () {0x400000;}' unless defined(&CR4_PKE);
eval 'sub XCR0_X87 () {0x1;}' unless defined(&XCR0_X87);
eval 'sub XCR0_SSE () {0x2;}' unless defined(&XCR0_SSE);
eval 'sub XCR0_YMM_Hi128 () {0x4;}' unless defined(&XCR0_YMM_Hi128);
eval 'sub XCR0_BNDREGS () {0x8;}' unless defined(&XCR0_BNDREGS);
eval 'sub XCR0_BNDCSR () {0x10;}' unless defined(&XCR0_BNDCSR);
eval 'sub XCR0_Opmask () {0x20;}' unless defined(&XCR0_Opmask);
eval 'sub XCR0_ZMM_Hi256 () {0x40;}' unless defined(&XCR0_ZMM_Hi256);
eval 'sub XCR0_Hi16_ZMM () {0x80;}' unless defined(&XCR0_Hi16_ZMM);
eval 'sub XCR0_FPU () {( &XCR0_X87 |  &XCR0_SSE |  &XCR0_YMM_Hi128 |  &XCR0_Opmask |  &XCR0_ZMM_Hi256 |  &XCR0_Hi16_ZMM);}' unless defined(&XCR0_FPU);
eval 'sub XCR0_BND () {( &XCR0_BNDREGS |  &XCR0_BNDCSR);}' unless defined(&XCR0_BND);
eval 'sub XCR0_FLAGS1 () {"\\20" "\\1" "x87" "\\2" "SSE" "\\3" "AVX" "\\4" "BNDREGS" "\\5" "BNDCSR" "\\6" "Opmask" "\\7" "ZMM_Hi256" "\\10" "Hi16_ZMM";}' unless defined(&XCR0_FLAGS1);
eval 'sub CPUID_FPU () {0x1;}' unless defined(&CPUID_FPU);
eval 'sub CPUID_VME () {0x2;}' unless defined(&CPUID_VME);
eval 'sub CPUID_DE () {0x4;}' unless defined(&CPUID_DE);
eval 'sub CPUID_PSE () {0x8;}' unless defined(&CPUID_PSE);
eval 'sub CPUID_TSC () {0x10;}' unless defined(&CPUID_TSC);
eval 'sub CPUID_MSR () {0x20;}' unless defined(&CPUID_MSR);
eval 'sub CPUID_PAE () {0x40;}' unless defined(&CPUID_PAE);
eval 'sub CPUID_MCE () {0x80;}' unless defined(&CPUID_MCE);
eval 'sub CPUID_CX8 () {0x100;}' unless defined(&CPUID_CX8);
eval 'sub CPUID_APIC () {0x200;}' unless defined(&CPUID_APIC);
eval 'sub CPUID_B10 () {0x400;}' unless defined(&CPUID_B10);
eval 'sub CPUID_SEP () {0x800;}' unless defined(&CPUID_SEP);
eval 'sub CPUID_MTRR () {0x1000;}' unless defined(&CPUID_MTRR);
eval 'sub CPUID_PGE () {0x2000;}' unless defined(&CPUID_PGE);
eval 'sub CPUID_MCA () {0x4000;}' unless defined(&CPUID_MCA);
eval 'sub CPUID_CMOV () {0x8000;}' unless defined(&CPUID_CMOV);
eval 'sub CPUID_PAT () {0x10000;}' unless defined(&CPUID_PAT);
eval 'sub CPUID_PSE36 () {0x20000;}' unless defined(&CPUID_PSE36);
eval 'sub CPUID_PN () {0x40000;}' unless defined(&CPUID_PN);
eval 'sub CPUID_CFLUSH () {0x80000;}' unless defined(&CPUID_CFLUSH);
eval 'sub CPUID_B20 () {0x100000;}' unless defined(&CPUID_B20);
eval 'sub CPUID_DS () {0x200000;}' unless defined(&CPUID_DS);
eval 'sub CPUID_ACPI () {0x400000;}' unless defined(&CPUID_ACPI);
eval 'sub CPUID_MMX () {0x800000;}' unless defined(&CPUID_MMX);
eval 'sub CPUID_FXSR () {0x1000000;}' unless defined(&CPUID_FXSR);
eval 'sub CPUID_SSE () {0x2000000;}' unless defined(&CPUID_SSE);
eval 'sub CPUID_SSE2 () {0x4000000;}' unless defined(&CPUID_SSE2);
eval 'sub CPUID_SS () {0x8000000;}' unless defined(&CPUID_SS);
eval 'sub CPUID_HTT () {0x10000000;}' unless defined(&CPUID_HTT);
eval 'sub CPUID_TM () {0x20000000;}' unless defined(&CPUID_TM);
eval 'sub CPUID_IA64 () {0x40000000;}' unless defined(&CPUID_IA64);
eval 'sub CPUID_SBF () {0x80000000;}' unless defined(&CPUID_SBF);
eval 'sub CPUID_FLAGS1 () {"\\20" "\\1" "FPU" "\\2" "VME" "\\3" "DE" "\\4" "PSE" "\\5" "TSC" "\\6" "MSR" "\\7" "PAE" "\\10" "MCE" "\\11" "CX8" "\\12" "APIC" "\\13" "B10" "\\14" "SEP" "\\15" "MTRR" "\\16" "PGE" "\\17" "MCA" "\\20" "CMOV" "\\21" "PAT" "\\22" "PSE36" "\\23" "PN" "\\24" "CLFLUSH" "\\25" "B20" "\\26" "DS" "\\27" "ACPI" "\\30" "MMX" "\\31" "FXSR" "\\32" "SSE" "\\33" "SSE2" "\\34" "SS" "\\35" "HTT" "\\36" "TM" "\\37" "IA64" "\\40" "SBF";}' unless defined(&CPUID_FLAGS1);
if(defined(&XEN)) {
    eval 'sub CPUID_FEAT_BLACKLIST () {( &CPUID_PGE| &CPUID_PSE| &CPUID_MTRR);}' unless defined(&CPUID_FEAT_BLACKLIST);
} else {
    eval 'sub CPUID_FEAT_BLACKLIST () {0;}' unless defined(&CPUID_FEAT_BLACKLIST);
}
eval 'sub CPUID2_SSE3 () {0x1;}' unless defined(&CPUID2_SSE3);
eval 'sub CPUID2_PCLMUL () {0x2;}' unless defined(&CPUID2_PCLMUL);
eval 'sub CPUID2_DTES64 () {0x4;}' unless defined(&CPUID2_DTES64);
eval 'sub CPUID2_MONITOR () {0x8;}' unless defined(&CPUID2_MONITOR);
eval 'sub CPUID2_DS_CPL () {0x10;}' unless defined(&CPUID2_DS_CPL);
eval 'sub CPUID2_VMX () {0x20;}' unless defined(&CPUID2_VMX);
eval 'sub CPUID2_SMX () {0x40;}' unless defined(&CPUID2_SMX);
eval 'sub CPUID2_EST () {0x80;}' unless defined(&CPUID2_EST);
eval 'sub CPUID2_TM2 () {0x100;}' unless defined(&CPUID2_TM2);
eval 'sub CPUID2_SSSE3 () {0x200;}' unless defined(&CPUID2_SSSE3);
eval 'sub CPUID2_CID () {0x400;}' unless defined(&CPUID2_CID);
eval 'sub CPUID2_SDBG () {0x800;}' unless defined(&CPUID2_SDBG);
eval 'sub CPUID2_FMA () {0x1000;}' unless defined(&CPUID2_FMA);
eval 'sub CPUID2_CX16 () {0x2000;}' unless defined(&CPUID2_CX16);
eval 'sub CPUID2_xTPR () {0x4000;}' unless defined(&CPUID2_xTPR);
eval 'sub CPUID2_PDCM () {0x8000;}' unless defined(&CPUID2_PDCM);
eval 'sub CPUID2_PCID () {0x20000;}' unless defined(&CPUID2_PCID);
eval 'sub CPUID2_DCA () {0x40000;}' unless defined(&CPUID2_DCA);
eval 'sub CPUID2_SSE41 () {0x80000;}' unless defined(&CPUID2_SSE41);
eval 'sub CPUID2_SSE42 () {0x100000;}' unless defined(&CPUID2_SSE42);
eval 'sub CPUID2_X2APIC () {0x200000;}' unless defined(&CPUID2_X2APIC);
eval 'sub CPUID2_MOVBE () {0x400000;}' unless defined(&CPUID2_MOVBE);
eval 'sub CPUID2_POPCNT () {0x800000;}' unless defined(&CPUID2_POPCNT);
eval 'sub CPUID2_DEADLINE () {0x1000000;}' unless defined(&CPUID2_DEADLINE);
eval 'sub CPUID2_AES () {0x2000000;}' unless defined(&CPUID2_AES);
eval 'sub CPUID2_XSAVE () {0x4000000;}' unless defined(&CPUID2_XSAVE);
eval 'sub CPUID2_OSXSAVE () {0x8000000;}' unless defined(&CPUID2_OSXSAVE);
eval 'sub CPUID2_AVX () {0x10000000;}' unless defined(&CPUID2_AVX);
eval 'sub CPUID2_F16C () {0x20000000;}' unless defined(&CPUID2_F16C);
eval 'sub CPUID2_RDRAND () {0x40000000;}' unless defined(&CPUID2_RDRAND);
eval 'sub CPUID2_RAZ () {0x80000000;}' unless defined(&CPUID2_RAZ);
eval 'sub CPUID2_FLAGS1 () {"\\20" "\\1" "SSE3" "\\2" "PCLMULQDQ" "\\3" "DTES64" "\\4" "MONITOR" "\\5" "DS-CPL" "\\6" "VMX" "\\7" "SMX" "\\10" "EST" "\\11" "TM2" "\\12" "SSSE3" "\\13" "CID" "\\14" "SDBG" "\\15" "FMA" "\\16" "CX16" "\\17" "xTPR" "\\20" "PDCM" "\\21" "B16" "\\22" "PCID" "\\23" "DCA" "\\24" "SSE41" "\\25" "SSE42" "\\26" "X2APIC" "\\27" "MOVBE" "\\30" "POPCNT" "\\31" "DEADLINE" "\\32" "AES" "\\33" "XSAVE" "\\34" "OSXSAVE" "\\35" "AVX" "\\36" "F16C" "\\37" "RDRAND" "\\40" "RAZ";}' unless defined(&CPUID2_FLAGS1);
unless(defined(&CPUID_TO_BASEFAMILY)) {
    sub CPUID_TO_BASEFAMILY {
	my($cpuid) = @_;
	eval q(((($cpuid) >> 8) & 0xf));
    }
}
unless(defined(&CPUID_TO_BASEMODEL)) {
    sub CPUID_TO_BASEMODEL {
	my($cpuid) = @_;
	eval q(((($cpuid) >> 4) & 0xf));
    }
}
unless(defined(&CPUID_TO_STEPPING)) {
    sub CPUID_TO_STEPPING {
	my($cpuid) = @_;
	eval q((($cpuid) & 0xf));
    }
}
unless(defined(&CPUID_TO_EXTFAMILY)) {
    sub CPUID_TO_EXTFAMILY {
	my($cpuid) = @_;
	eval q(((($cpuid) >> 20) & 0xff));
    }
}
unless(defined(&CPUID_TO_EXTMODEL)) {
    sub CPUID_TO_EXTMODEL {
	my($cpuid) = @_;
	eval q(((($cpuid) >> 16) & 0xf));
    }
}
unless(defined(&CPUID_TO_FAMILY)) {
    sub CPUID_TO_FAMILY {
	my($cpuid) = @_;
	eval q(( &CPUID_TO_BASEFAMILY($cpuid) + (( &CPUID_TO_BASEFAMILY($cpuid) != 0xf) ? 0:  &CPUID_TO_EXTFAMILY($cpuid))));
    }
}
unless(defined(&CPUID_TO_MODEL)) {
    sub CPUID_TO_MODEL {
	my($cpuid) = @_;
	eval q(( &CPUID_TO_BASEMODEL($cpuid) | (( &CPUID_TO_BASEFAMILY($cpuid) != 0xf)  && ( &CPUID_TO_BASEFAMILY($cpuid) != 0x6) ? 0: ( &CPUID_TO_EXTMODEL($cpuid) << 4))));
    }
}
eval 'sub CPUID_BRAND_INDEX () { &__BITS(7,0);}' unless defined(&CPUID_BRAND_INDEX);
eval 'sub CPUID_CLFLUSH_SIZE () { &__BITS(15,8);}' unless defined(&CPUID_CLFLUSH_SIZE);
eval 'sub CPUID_HTT_CORES () { &__BITS(23,16);}' unless defined(&CPUID_HTT_CORES);
eval 'sub CPUID_LOCAL_APIC_ID () { &__BITS(31,24);}' unless defined(&CPUID_LOCAL_APIC_ID);
eval 'sub CPUID_DCP_CACHETYPE () { &__BITS(4, 0);}' unless defined(&CPUID_DCP_CACHETYPE);
eval 'sub CPUID_DCP_CACHETYPE_N () {0;}' unless defined(&CPUID_DCP_CACHETYPE_N);
eval 'sub CPUID_DCP_CACHETYPE_D () {1;}' unless defined(&CPUID_DCP_CACHETYPE_D);
eval 'sub CPUID_DCP_CACHETYPE_I () {2;}' unless defined(&CPUID_DCP_CACHETYPE_I);
eval 'sub CPUID_DCP_CACHETYPE_U () {3;}' unless defined(&CPUID_DCP_CACHETYPE_U);
eval 'sub CPUID_DCP_CACHELEVEL () { &__BITS(7, 5);}' unless defined(&CPUID_DCP_CACHELEVEL);
eval 'sub CPUID_DCP_SELFINITCL () { &__BIT(8);}' unless defined(&CPUID_DCP_SELFINITCL);
eval 'sub CPUID_DCP_FULLASSOC () { &__BIT(9);}' unless defined(&CPUID_DCP_FULLASSOC);
eval 'sub CPUID_DCP_SHAREING () { &__BITS(25, 14);}' unless defined(&CPUID_DCP_SHAREING);
eval 'sub CPUID_DCP_CORE_P_PKG () { &__BITS(31, 26);}' unless defined(&CPUID_DCP_CORE_P_PKG);
eval 'sub CPUID_DCP_LINESIZE () { &__BITS(11, 0);}' unless defined(&CPUID_DCP_LINESIZE);
eval 'sub CPUID_DCP_PARTITIONS () { &__BITS(21, 12);}' unless defined(&CPUID_DCP_PARTITIONS);
eval 'sub CPUID_DCP_WAYS () { &__BITS(31, 22);}' unless defined(&CPUID_DCP_WAYS);
eval 'sub CPUID_DCP_INVALIDATE () { &__BIT(0);}' unless defined(&CPUID_DCP_INVALIDATE);
eval 'sub CPUID_DCP_INCLUSIVE () { &__BIT(1);}' unless defined(&CPUID_DCP_INCLUSIVE);
eval 'sub CPUID_DCP_COMPLEX () { &__BIT(2);}' unless defined(&CPUID_DCP_COMPLEX);
eval 'sub CPUID_DSPM_DTS () { &__BIT(0);}' unless defined(&CPUID_DSPM_DTS);
eval 'sub CPUID_DSPM_IDA () { &__BIT(1);}' unless defined(&CPUID_DSPM_IDA);
eval 'sub CPUID_DSPM_ARAT () { &__BIT(2);}' unless defined(&CPUID_DSPM_ARAT);
eval 'sub CPUID_DSPM_PLN () { &__BIT(4);}' unless defined(&CPUID_DSPM_PLN);
eval 'sub CPUID_DSPM_ECMD () { &__BIT(5);}' unless defined(&CPUID_DSPM_ECMD);
eval 'sub CPUID_DSPM_PTM () { &__BIT(6);}' unless defined(&CPUID_DSPM_PTM);
eval 'sub CPUID_DSPM_HWP () { &__BIT(7);}' unless defined(&CPUID_DSPM_HWP);
eval 'sub CPUID_DSPM_HWP_NOTIFY () { &__BIT(8);}' unless defined(&CPUID_DSPM_HWP_NOTIFY);
eval 'sub CPUID_DSPM_HWP_ACTWIN () { &__BIT(9);}' unless defined(&CPUID_DSPM_HWP_ACTWIN);
eval 'sub CPUID_DSPM_HWP_EPP () { &__BIT(10);}' unless defined(&CPUID_DSPM_HWP_EPP);
eval 'sub CPUID_DSPM_HWP_PLR () { &__BIT(11);}' unless defined(&CPUID_DSPM_HWP_PLR);
eval 'sub CPUID_DSPM_HDC () { &__BIT(13);}' unless defined(&CPUID_DSPM_HDC);
eval 'sub CPUID_DSPM_TBMT3 () { &__BIT(14);}' unless defined(&CPUID_DSPM_TBMT3);
eval 'sub CPUID_DSPM_HWP_CAP () { &__BIT(15);}' unless defined(&CPUID_DSPM_HWP_CAP);
eval 'sub CPUID_DSPM_HWP_PECI () { &__BIT(16);}' unless defined(&CPUID_DSPM_HWP_PECI);
eval 'sub CPUID_DSPM_HWP_FLEX () { &__BIT(17);}' unless defined(&CPUID_DSPM_HWP_FLEX);
eval 'sub CPUID_DSPM_HWP_FAST () { &__BIT(18);}' unless defined(&CPUID_DSPM_HWP_FAST);
eval 'sub CPUID_DSPM_HWP_IGNIDL () { &__BIT(20);}' unless defined(&CPUID_DSPM_HWP_IGNIDL);
eval 'sub CPUID_DSPM_FLAGS () {"\\20" "\\1" "DTS" "\\2" "IDA" "\\3" "ARAT" "\\5" "PLN" "\\6" "ECMD" "\\7" "PTM" "\\10" "HWP" "\\11" "HWP_NOTIFY" "\\12" "HWP_ACTWIN" "\\13" "HWP_EPP" "\\14" "HWP_PLR" "\\16" "HDC" "\\17" "TBM3" "\\20" "HWP_CAP" "\\21" "HWP_PECI" "\\22" "HWP_FLEX" "\\23" "HWP_FAST" "25" "HWP_IGNIDL";}' unless defined(&CPUID_DSPM_FLAGS);
eval 'sub CPUID_DSPM_HWF () {0x1;}' unless defined(&CPUID_DSPM_HWF);
eval 'sub CPUID_DSPM_EPB () {0x8;}' unless defined(&CPUID_DSPM_EPB);
eval 'sub CPUID_DSPM_FLAGS1 () {"\\20" "\\1" "HWF" "\\4" "EPB";}' unless defined(&CPUID_DSPM_FLAGS1);
eval 'sub CPUID_SEF_FSGSBASE () { &__BIT(0);}' unless defined(&CPUID_SEF_FSGSBASE);
eval 'sub CPUID_SEF_TSC_ADJUST () { &__BIT(1);}' unless defined(&CPUID_SEF_TSC_ADJUST);
eval 'sub CPUID_SEF_SGX () { &__BIT(2);}' unless defined(&CPUID_SEF_SGX);
eval 'sub CPUID_SEF_BMI1 () { &__BIT(3);}' unless defined(&CPUID_SEF_BMI1);
eval 'sub CPUID_SEF_HLE () { &__BIT(4);}' unless defined(&CPUID_SEF_HLE);
eval 'sub CPUID_SEF_AVX2 () { &__BIT(5);}' unless defined(&CPUID_SEF_AVX2);
eval 'sub CPUID_SEF_FDPEXONLY () { &__BIT(6);}' unless defined(&CPUID_SEF_FDPEXONLY);
eval 'sub CPUID_SEF_SMEP () { &__BIT(7);}' unless defined(&CPUID_SEF_SMEP);
eval 'sub CPUID_SEF_BMI2 () { &__BIT(8);}' unless defined(&CPUID_SEF_BMI2);
eval 'sub CPUID_SEF_ERMS () { &__BIT(9);}' unless defined(&CPUID_SEF_ERMS);
eval 'sub CPUID_SEF_INVPCID () { &__BIT(10);}' unless defined(&CPUID_SEF_INVPCID);
eval 'sub CPUID_SEF_RTM () { &__BIT(11);}' unless defined(&CPUID_SEF_RTM);
eval 'sub CPUID_SEF_QM () { &__BIT(12);}' unless defined(&CPUID_SEF_QM);
eval 'sub CPUID_SEF_FPUCSDS () { &__BIT(13);}' unless defined(&CPUID_SEF_FPUCSDS);
eval 'sub CPUID_SEF_MPX () { &__BIT(14);}' unless defined(&CPUID_SEF_MPX);
eval 'sub CPUID_SEF_PQE () { &__BIT(15);}' unless defined(&CPUID_SEF_PQE);
eval 'sub CPUID_SEF_AVX512F () { &__BIT(16);}' unless defined(&CPUID_SEF_AVX512F);
eval 'sub CPUID_SEF_AVX512DQ () { &__BIT(17);}' unless defined(&CPUID_SEF_AVX512DQ);
eval 'sub CPUID_SEF_RDSEED () { &__BIT(18);}' unless defined(&CPUID_SEF_RDSEED);
eval 'sub CPUID_SEF_ADX () { &__BIT(19);}' unless defined(&CPUID_SEF_ADX);
eval 'sub CPUID_SEF_SMAP () { &__BIT(20);}' unless defined(&CPUID_SEF_SMAP);
eval 'sub CPUID_SEF_AVX512_IFMA () { &__BIT(21);}' unless defined(&CPUID_SEF_AVX512_IFMA);
eval 'sub CPUID_SEF_CLFLUSHOPT () { &__BIT(23);}' unless defined(&CPUID_SEF_CLFLUSHOPT);
eval 'sub CPUID_SEF_CLWB () { &__BIT(24);}' unless defined(&CPUID_SEF_CLWB);
eval 'sub CPUID_SEF_PT () { &__BIT(25);}' unless defined(&CPUID_SEF_PT);
eval 'sub CPUID_SEF_AVX512PF () { &__BIT(26);}' unless defined(&CPUID_SEF_AVX512PF);
eval 'sub CPUID_SEF_AVX512ER () { &__BIT(27);}' unless defined(&CPUID_SEF_AVX512ER);
eval 'sub CPUID_SEF_AVX512CD () { &__BIT(28);}' unless defined(&CPUID_SEF_AVX512CD);
eval 'sub CPUID_SEF_SHA () { &__BIT(29);}' unless defined(&CPUID_SEF_SHA);
eval 'sub CPUID_SEF_AVX512BW () { &__BIT(30);}' unless defined(&CPUID_SEF_AVX512BW);
eval 'sub CPUID_SEF_AVX512VL () { &__BIT(31);}' unless defined(&CPUID_SEF_AVX512VL);
eval 'sub CPUID_SEF_FLAGS () {"\\20" "\\1" "FSGSBASE" "\\2" "TSCADJUST" "\\3" "SGX" "\\4" "BMI1" "\\5" "HLE" "\\6" "AVX2" "\\7" "FDPEXONLY" "\\10" "SMEP" "\\11" "BMI2" "\\12" "ERMS" "\\13" "INVPCID" "\\14" "RTM" "\\15" "QM" "\\16" "FPUCSDS" "\\17" "MPX" "\\20" "PQE" "\\21" "AVX512F" "\\22" "AVX512DQ" "\\23" "RDSEED" "\\24" "ADX" "\\25" "SMAP" "\\26" "AVX512_IFMA" "\\30" "CLFLUSHOPT" "\\31" "CLWB" "\\32" "PT" "\\33" "AVX512PF" "\\34" "AVX512ER" "\\35" "AVX512CD""\\36" "SHA" "\\37" "AVX512BW" "\\40" "AVX512VL";}' unless defined(&CPUID_SEF_FLAGS);
eval 'sub CPUID_SEF_PREFETCHWT1 () { &__BIT(0);}' unless defined(&CPUID_SEF_PREFETCHWT1);
eval 'sub CPUID_SEF_AVX512_VBMI () { &__BIT(1);}' unless defined(&CPUID_SEF_AVX512_VBMI);
eval 'sub CPUID_SEF_UMIP () { &__BIT(2);}' unless defined(&CPUID_SEF_UMIP);
eval 'sub CPUID_SEF_PKU () { &__BIT(3);}' unless defined(&CPUID_SEF_PKU);
eval 'sub CPUID_SEF_OSPKE () { &__BIT(4);}' unless defined(&CPUID_SEF_OSPKE);
eval 'sub CPUID_SEF_AVX512_VBMI2 () { &__BIT(6);}' unless defined(&CPUID_SEF_AVX512_VBMI2);
eval 'sub CPUID_SEF_GFNI () { &__BIT(8);}' unless defined(&CPUID_SEF_GFNI);
eval 'sub CPUID_SEF_VAES () { &__BIT(9);}' unless defined(&CPUID_SEF_VAES);
eval 'sub CPUID_SEF_VPCLMULQDQ () { &__BIT(10);}' unless defined(&CPUID_SEF_VPCLMULQDQ);
eval 'sub CPUID_SEF_AVX512_VNNI () { &__BIT(11);}' unless defined(&CPUID_SEF_AVX512_VNNI);
eval 'sub CPUID_SEF_AVX512_BITALG () { &__BIT(12);}' unless defined(&CPUID_SEF_AVX512_BITALG);
eval 'sub CPUID_SEF_AVX512_VPOPCNTDQ () { &__BIT(14);}' unless defined(&CPUID_SEF_AVX512_VPOPCNTDQ);
eval 'sub CPUID_SEF_RDPID () { &__BIT(22);}' unless defined(&CPUID_SEF_RDPID);
eval 'sub CPUID_SEF_SGXLC () { &__BIT(30);}' unless defined(&CPUID_SEF_SGXLC);
eval 'sub CPUID_SEF_FLAGS1 () {"\\20" "\\1" "PREFETCHWT1" "\\2" "AVX512_VBMI" "\\3" "UMIP" "\\4" "PKU" "\\5" "OSPKE" "\\7" "AVX512_VBMI2" "\\11" "GFNI" "\\12" "VAES" "\\13" "VPCLMULQDQ" "\\14" "AVX512_VNNI" "\\15" "AVX512_BITALG" "\\17" "AVX512_VPOPCNTDQ" "\\27" "RDPID" "\\37" "SGXLC";}' unless defined(&CPUID_SEF_FLAGS1);
eval 'sub CPUID_SEF_AVX512_4VNNIW () { &__BIT(2);}' unless defined(&CPUID_SEF_AVX512_4VNNIW);
eval 'sub CPUID_SEF_AVX512_4FMAPS () { &__BIT(3);}' unless defined(&CPUID_SEF_AVX512_4FMAPS);
eval 'sub CPUID_SEF_IBRS () { &__BIT(26);}' unless defined(&CPUID_SEF_IBRS);
eval 'sub CPUID_SEF_STIBP () { &__BIT(27);}' unless defined(&CPUID_SEF_STIBP);
eval 'sub CPUID_SEF_ARCH_CAP () { &__BIT(29);}' unless defined(&CPUID_SEF_ARCH_CAP);
eval 'sub CPUID_SEF_SSBD () { &__BIT(31);}' unless defined(&CPUID_SEF_SSBD);
eval 'sub CPUID_SEF_FLAGS2 () {"\\20" "\\3" "AVX512_4VNNIW" "\\4" "AVX512_4FMAPS" "\\33" "IBRS" "\\34" "STIBP" "\\36" "ARCH_CAP" "\\40" "SSBD";}' unless defined(&CPUID_SEF_FLAGS2);
eval 'sub CPUID_PES1_XSAVEOPT () {0x1;}' unless defined(&CPUID_PES1_XSAVEOPT);
eval 'sub CPUID_PES1_XSAVEC () {0x2;}' unless defined(&CPUID_PES1_XSAVEC);
eval 'sub CPUID_PES1_XGETBV () {0x4;}' unless defined(&CPUID_PES1_XGETBV);
eval 'sub CPUID_PES1_XSAVES () {0x8;}' unless defined(&CPUID_PES1_XSAVES);
eval 'sub CPUID_PES1_FLAGS () {"\\20" "\\1" "XSAVEOPT" "\\2" "XSAVEC" "\\3" "XGETBV" "\\4" "XSAVES";}' unless defined(&CPUID_PES1_FLAGS);
eval 'sub CPUID_DATP_PGSIZE () { &__BITS(3, 0);}' unless defined(&CPUID_DATP_PGSIZE);
eval 'sub CPUID_DATP_PGSIZE_4KB () { &__BIT(0);}' unless defined(&CPUID_DATP_PGSIZE_4KB);
eval 'sub CPUID_DATP_PGSIZE_2MB () { &__BIT(1);}' unless defined(&CPUID_DATP_PGSIZE_2MB);
eval 'sub CPUID_DATP_PGSIZE_4MB () { &__BIT(2);}' unless defined(&CPUID_DATP_PGSIZE_4MB);
eval 'sub CPUID_DATP_PGSIZE_1GB () { &__BIT(3);}' unless defined(&CPUID_DATP_PGSIZE_1GB);
eval 'sub CPUID_DATP_PARTITIONING () { &__BITS(10, 8);}' unless defined(&CPUID_DATP_PARTITIONING);
eval 'sub CPUID_DATP_WAYS () { &__BITS(31, 16);}' unless defined(&CPUID_DATP_WAYS);
eval 'sub CPUID_DATP_TCTYPE () { &__BITS(4, 0);}' unless defined(&CPUID_DATP_TCTYPE);
eval 'sub CPUID_DATP_TCTYPE_N () {0;}' unless defined(&CPUID_DATP_TCTYPE_N);
eval 'sub CPUID_DATP_TCTYPE_D () {1;}' unless defined(&CPUID_DATP_TCTYPE_D);
eval 'sub CPUID_DATP_TCTYPE_I () {2;}' unless defined(&CPUID_DATP_TCTYPE_I);
eval 'sub CPUID_DATP_TCTYPE_U () {3;}' unless defined(&CPUID_DATP_TCTYPE_U);
eval 'sub CPUID_DATP_TCLEVEL () { &__BITS(7, 5);}' unless defined(&CPUID_DATP_TCLEVEL);
eval 'sub CPUID_DATP_FULLASSOC () { &__BIT(8);}' unless defined(&CPUID_DATP_FULLASSOC);
eval 'sub CPUID_DATP_SHAREING () { &__BITS(25, 14);}' unless defined(&CPUID_DATP_SHAREING);
eval 'sub CPUID_SYSCALL () {0x800;}' unless defined(&CPUID_SYSCALL);
eval 'sub CPUID_XD () {0x100000;}' unless defined(&CPUID_XD);
eval 'sub CPUID_P1GB () {0x4000000;}' unless defined(&CPUID_P1GB);
eval 'sub CPUID_RDTSCP () {0x8000000;}' unless defined(&CPUID_RDTSCP);
eval 'sub CPUID_EM64T () {0x20000000;}' unless defined(&CPUID_EM64T);
eval 'sub CPUID_INTEL_EXT_FLAGS () {"\\20" "\\14" "SYSCALL/SYSRET" "\\25" "XD" "\\33" "P1GB" "\\34" "RDTSCP" "\\36" "EM64T";}' unless defined(&CPUID_INTEL_EXT_FLAGS);
eval 'sub CPUID_LAHF () {0x1;}' unless defined(&CPUID_LAHF);
eval 'sub CPUID_PREFETCHW () {0x100;}' unless defined(&CPUID_PREFETCHW);
eval 'sub CPUID_INTEL_FLAGS4 () {"\\20" "\\1" "LAHF" "\\02" "B01" "\\03" "B02" "\\06" "LZCNT" "\\11" "PREFETCHW";}' unless defined(&CPUID_INTEL_FLAGS4);
eval 'sub CPUID_MPC () {0x80000;}' unless defined(&CPUID_MPC);
eval 'sub CPUID_NOX () {0x100000;}' unless defined(&CPUID_NOX);
eval 'sub CPUID_MMXX () {0x400000;}' unless defined(&CPUID_MMXX);
eval 'sub CPUID_FFXSR () {0x2000000;}' unless defined(&CPUID_FFXSR);
eval 'sub CPUID_3DNOW2 () {0x40000000;}' unless defined(&CPUID_3DNOW2);
eval 'sub CPUID_3DNOW () {0x80000000;}' unless defined(&CPUID_3DNOW);
eval 'sub CPUID_EXT_FLAGS () {"\\20" "\\14" "SYSCALL/SYSRET" "\\24" "MPC" "\\25" "NOX" "\\27" "MMXX" "\\30" "MMX" "\\31" "FXSR" "\\32" "FFXSR" "\\33" "P1GB" "\\34" "RDTSCP" "\\36" "LONG" "\\37" "3DNOW2" "\\40" "3DNOW";}' unless defined(&CPUID_EXT_FLAGS);
eval 'sub CPUID_CMPLEGACY () {0x2;}' unless defined(&CPUID_CMPLEGACY);
eval 'sub CPUID_SVM () {0x4;}' unless defined(&CPUID_SVM);
eval 'sub CPUID_EAPIC () {0x8;}' unless defined(&CPUID_EAPIC);
eval 'sub CPUID_ALTMOVCR0 () {0x10;}' unless defined(&CPUID_ALTMOVCR0);
eval 'sub CPUID_LZCNT () {0x20;}' unless defined(&CPUID_LZCNT);
eval 'sub CPUID_SSE4A () {0x40;}' unless defined(&CPUID_SSE4A);
eval 'sub CPUID_MISALIGNSSE () {0x80;}' unless defined(&CPUID_MISALIGNSSE);
eval 'sub CPUID_3DNOWPF () {0x100;}' unless defined(&CPUID_3DNOWPF);
eval 'sub CPUID_OSVW () {0x200;}' unless defined(&CPUID_OSVW);
eval 'sub CPUID_IBS () {0x400;}' unless defined(&CPUID_IBS);
eval 'sub CPUID_XOP () {0x800;}' unless defined(&CPUID_XOP);
eval 'sub CPUID_SKINIT () {0x1000;}' unless defined(&CPUID_SKINIT);
eval 'sub CPUID_WDT () {0x2000;}' unless defined(&CPUID_WDT);
eval 'sub CPUID_LWP () {0x8000;}' unless defined(&CPUID_LWP);
eval 'sub CPUID_FMA4 () {0x10000;}' unless defined(&CPUID_FMA4);
eval 'sub CPUID_TCE () {0x20000;}' unless defined(&CPUID_TCE);
eval 'sub CPUID_NODEID () {0x80000;}' unless defined(&CPUID_NODEID);
eval 'sub CPUID_TBM () {0x200000;}' unless defined(&CPUID_TBM);
eval 'sub CPUID_TOPOEXT () {0x400000;}' unless defined(&CPUID_TOPOEXT);
eval 'sub CPUID_PCEC () {0x800000;}' unless defined(&CPUID_PCEC);
eval 'sub CPUID_PCENB () {0x1000000;}' unless defined(&CPUID_PCENB);
eval 'sub CPUID_SPM () {0x2000000;}' unless defined(&CPUID_SPM);
eval 'sub CPUID_DBE () {0x4000000;}' unless defined(&CPUID_DBE);
eval 'sub CPUID_PTSC () {0x8000000;}' unless defined(&CPUID_PTSC);
eval 'sub CPUID_L2IPERFC () {0x10000000;}' unless defined(&CPUID_L2IPERFC);
eval 'sub CPUID_MWAITX () {0x20000000;}' unless defined(&CPUID_MWAITX);
eval 'sub CPUID_AMD_FLAGS4 () {"\\20" "\\1" "LAHF" "\\2" "CMPLEGACY" "\\3" "SVM" "\\4" "EAPIC" "\\5" "ALTMOVCR0" "\\6" "LZCNT" "\\7" "SSE4A" "\\10" "MISALIGNSSE" "\\11" "3DNOWPREFETCH" "\\12" "OSVW" "\\13" "IBS" "\\14" "XOP" "\\15" "SKINIT" "\\16" "WDT" "\\17" "B14" "\\20" "LWP" "\\21" "FMA4" "\\22" "TCE" "\\23" "B18" "\\24" "NodeID" "\\25" "B20" "\\26" "TBM" "\\27" "TopoExt" "\\30" "PCExtC" "\\31" "PCExtNB" "\\32" "StrmPM" "\\33" "DBExt" "\\34" "PerfTsc" "\\35" "L2IPERFC" "\\36" "MWAITX" "\\37" "B30" "\\40" "B31";}' unless defined(&CPUID_AMD_FLAGS4);
eval 'sub CPUID_APM_TS () {0x1;}' unless defined(&CPUID_APM_TS);
eval 'sub CPUID_APM_FID () {0x2;}' unless defined(&CPUID_APM_FID);
eval 'sub CPUID_APM_VID () {0x4;}' unless defined(&CPUID_APM_VID);
eval 'sub CPUID_APM_TTP () {0x8;}' unless defined(&CPUID_APM_TTP);
eval 'sub CPUID_APM_HTC () {0x10;}' unless defined(&CPUID_APM_HTC);
eval 'sub CPUID_APM_STC () {0x20;}' unless defined(&CPUID_APM_STC);
eval 'sub CPUID_APM_100 () {0x40;}' unless defined(&CPUID_APM_100);
eval 'sub CPUID_APM_HWP () {0x80;}' unless defined(&CPUID_APM_HWP);
eval 'sub CPUID_APM_TSC () {0x100;}' unless defined(&CPUID_APM_TSC);
eval 'sub CPUID_APM_CPB () {0x200;}' unless defined(&CPUID_APM_CPB);
eval 'sub CPUID_APM_EFF () {0x400;}' unless defined(&CPUID_APM_EFF);
eval 'sub CPUID_APM_FLAGS () {"\\20" "\\1" "TS" "\\2" "FID" "\\3" "VID" "\\4" "TTP" "\\5" "HTC" "\\6" "STC" "\\7" "100" "\\10" "HWP" "\\11" "TSC" "\\12" "CPB" "\\13" "EffFreq" "\\14" "B11" "\\15" "B12";}' unless defined(&CPUID_APM_FLAGS);
eval 'sub CPUID_AMD_SVM_NP () {0x1;}' unless defined(&CPUID_AMD_SVM_NP);
eval 'sub CPUID_AMD_SVM_LbrVirt () {0x2;}' unless defined(&CPUID_AMD_SVM_LbrVirt);
eval 'sub CPUID_AMD_SVM_SVML () {0x4;}' unless defined(&CPUID_AMD_SVM_SVML);
eval 'sub CPUID_AMD_SVM_NRIPS () {0x8;}' unless defined(&CPUID_AMD_SVM_NRIPS);
eval 'sub CPUID_AMD_SVM_TSCRateCtrl () {0x10;}' unless defined(&CPUID_AMD_SVM_TSCRateCtrl);
eval 'sub CPUID_AMD_SVM_VMCBCleanBits () {0x20;}' unless defined(&CPUID_AMD_SVM_VMCBCleanBits);
eval 'sub CPUID_AMD_SVM_FlushByASID () {0x40;}' unless defined(&CPUID_AMD_SVM_FlushByASID);
eval 'sub CPUID_AMD_SVM_DecodeAssist () {0x80;}' unless defined(&CPUID_AMD_SVM_DecodeAssist);
eval 'sub CPUID_AMD_SVM_PauseFilter () {0x400;}' unless defined(&CPUID_AMD_SVM_PauseFilter);
eval 'sub CPUID_AMD_SVM_PFThreshold () {0x &x001000;}' unless defined(&CPUID_AMD_SVM_PFThreshold);
eval 'sub CPUID_AMD_SVM_AVIC () {0x2000;}' unless defined(&CPUID_AMD_SVM_AVIC);
eval 'sub CPUID_AMD_SVM_V_VMSAVE_VMLOAD () {0x8000;}' unless defined(&CPUID_AMD_SVM_V_VMSAVE_VMLOAD);
eval 'sub CPUID_AMD_SVM_vGIF () {0x10000;}' unless defined(&CPUID_AMD_SVM_vGIF);
eval 'sub CPUID_AMD_SVM_FLAGS () {"\\20" "\\1" "NP" "\\2" "LbrVirt" "\\3" "SVML" "\\4" "NRIPS" "\\5" "TSCRate" "\\6" "VMCBCleanBits" "\\7" "FlushByASID" "\\10" "DecodeAssist" "\\11" "B08" "\\12" "B09" "\\13" "PauseFilter" "\\14" "B11" "\\15" "PFThreshold" "\\16" "AVIC" "\\17" "B14" "\\20" "V_VMSAVE_VMLOAD" "\\21" "VGIF";}' unless defined(&CPUID_AMD_SVM_FLAGS);
eval 'sub CPUID_VIA_HAS_RNG () {0x4;}' unless defined(&CPUID_VIA_HAS_RNG);
eval 'sub CPUID_VIA_DO_RNG () {0x8;}' unless defined(&CPUID_VIA_DO_RNG);
eval 'sub CPUID_VIA_HAS_ACE () {0x40;}' unless defined(&CPUID_VIA_HAS_ACE);
eval 'sub CPUID_VIA_DO_ACE () {0x80;}' unless defined(&CPUID_VIA_DO_ACE);
eval 'sub CPUID_VIA_HAS_ACE2 () {0x100;}' unless defined(&CPUID_VIA_HAS_ACE2);
eval 'sub CPUID_VIA_DO_ACE2 () {0x200;}' unless defined(&CPUID_VIA_DO_ACE2);
eval 'sub CPUID_VIA_HAS_PHE () {0x400;}' unless defined(&CPUID_VIA_HAS_PHE);
eval 'sub CPUID_VIA_DO_PHE () {0x800;}' unless defined(&CPUID_VIA_DO_PHE);
eval 'sub CPUID_VIA_HAS_PMM () {0x1000;}' unless defined(&CPUID_VIA_HAS_PMM);
eval 'sub CPUID_VIA_DO_PMM () {0x2000;}' unless defined(&CPUID_VIA_DO_PMM);
eval 'sub CPUID_FLAGS_PADLOCK () {"\\20" "\\3" "RNG" "\\7" "AES" "\\11" "AES/CTR" "\\13" "SHA1/SHA256" "\\15" "RSA";}' unless defined(&CPUID_FLAGS_PADLOCK);
eval 'sub MSR_P5_MC_ADDR () {0x;}' unless defined(&MSR_P5_MC_ADDR);
eval 'sub MSR_P5_MC_TYPE () {0x1;}' unless defined(&MSR_P5_MC_TYPE);
eval 'sub MSR_TSC () {0x10;}' unless defined(&MSR_TSC);
eval 'sub MSR_CESR () {0x11;}' unless defined(&MSR_CESR);
eval 'sub MSR_CTR0 () {0x12;}' unless defined(&MSR_CTR0);
eval 'sub MSR_CTR1 () {0x13;}' unless defined(&MSR_CTR1);
eval 'sub MSR_IA32_PLATFORM_ID () {0x17;}' unless defined(&MSR_IA32_PLATFORM_ID);
eval 'sub MSR_APICBASE () {0x1b;}' unless defined(&MSR_APICBASE);
eval 'sub APICBASE_BSP () {0x100;}' unless defined(&APICBASE_BSP);
eval 'sub APICBASE_EXTD () {0x400;}' unless defined(&APICBASE_EXTD);
eval 'sub APICBASE_EN () {0x800;}' unless defined(&APICBASE_EN);
eval 'sub APICBASE_PHYSADDR () {0xfffff000;}' unless defined(&APICBASE_PHYSADDR);
eval 'sub MSR_EBL_CR_POWERON () {0x2a;}' unless defined(&MSR_EBL_CR_POWERON);
eval 'sub MSR_EBC_FREQUENCY_ID () {0x2c;}' unless defined(&MSR_EBC_FREQUENCY_ID);
eval 'sub MSR_TEST_CTL () {0x33;}' unless defined(&MSR_TEST_CTL);
eval 'sub MSR_IA32_SPEC_CTRL () {0x48;}' unless defined(&MSR_IA32_SPEC_CTRL);
eval 'sub IA32_SPEC_CTRL_IBRS () {0x1;}' unless defined(&IA32_SPEC_CTRL_IBRS);
eval 'sub IA32_SPEC_CTRL_STIBP () {0x2;}' unless defined(&IA32_SPEC_CTRL_STIBP);
eval 'sub IA32_SPEC_CTRL_SSBD () {0x4;}' unless defined(&IA32_SPEC_CTRL_SSBD);
eval 'sub MSR_IA32_PRED_CMD () {0x49;}' unless defined(&MSR_IA32_PRED_CMD);
eval 'sub IA32_PRED_CMD_IBPB () {0x1;}' unless defined(&IA32_PRED_CMD_IBPB);
eval 'sub MSR_BIOS_UPDT_TRIG () {0x79;}' unless defined(&MSR_BIOS_UPDT_TRIG);
eval 'sub MSR_BBL_CR_D0 () {0x88;}' unless defined(&MSR_BBL_CR_D0);
eval 'sub MSR_BBL_CR_D1 () {0x89;}' unless defined(&MSR_BBL_CR_D1);
eval 'sub MSR_BBL_CR_D2 () {0x8a;}' unless defined(&MSR_BBL_CR_D2);
eval 'sub MSR_BIOS_SIGN () {0x8b;}' unless defined(&MSR_BIOS_SIGN);
eval 'sub MSR_PERFCTR0 () {0xc1;}' unless defined(&MSR_PERFCTR0);
eval 'sub MSR_PERFCTR1 () {0xc2;}' unless defined(&MSR_PERFCTR1);
eval 'sub MSR_FSB_FREQ () {0xcd;}' unless defined(&MSR_FSB_FREQ);
eval 'sub MSR_MPERF () {0xe7;}' unless defined(&MSR_MPERF);
eval 'sub MSR_APERF () {0xe8;}' unless defined(&MSR_APERF);
eval 'sub MSR_IA32_EXT_CONFIG () {0xee;}' unless defined(&MSR_IA32_EXT_CONFIG);
eval 'sub MSR_MTRRcap () {0xfe;}' unless defined(&MSR_MTRRcap);
eval 'sub MSR_IA32_ARCH_CAPABILITIES () {0x10a;}' unless defined(&MSR_IA32_ARCH_CAPABILITIES);
eval 'sub IA32_ARCH_RDCL_NO () {0x1;}' unless defined(&IA32_ARCH_RDCL_NO);
eval 'sub IA32_ARCH_IBRS_ALL () {0x2;}' unless defined(&IA32_ARCH_IBRS_ALL);
eval 'sub IA32_ARCH_RSBA () {0x4;}' unless defined(&IA32_ARCH_RSBA);
eval 'sub IA32_ARCH_SSB_NO () {0x10;}' unless defined(&IA32_ARCH_SSB_NO);
eval 'sub MSR_BBL_CR_ADDR () {0x116;}' unless defined(&MSR_BBL_CR_ADDR);
eval 'sub MSR_BBL_CR_DECC () {0x118;}' unless defined(&MSR_BBL_CR_DECC);
eval 'sub MSR_BBL_CR_CTL () {0x119;}' unless defined(&MSR_BBL_CR_CTL);
eval 'sub MSR_BBL_CR_TRIG () {0x11a;}' unless defined(&MSR_BBL_CR_TRIG);
eval 'sub MSR_BBL_CR_BUSY () {0x11b;}' unless defined(&MSR_BBL_CR_BUSY);
eval 'sub MSR_BBL_CR_CTR3 () {0x11e;}' unless defined(&MSR_BBL_CR_CTR3);
eval 'sub MSR_SYSENTER_CS () {0x174;}' unless defined(&MSR_SYSENTER_CS);
eval 'sub MSR_SYSENTER_ESP () {0x175;}' unless defined(&MSR_SYSENTER_ESP);
eval 'sub MSR_SYSENTER_EIP () {0x176;}' unless defined(&MSR_SYSENTER_EIP);
eval 'sub MSR_MCG_CAP () {0x179;}' unless defined(&MSR_MCG_CAP);
eval 'sub MSR_MCG_STATUS () {0x17a;}' unless defined(&MSR_MCG_STATUS);
eval 'sub MSR_MCG_CTL () {0x17b;}' unless defined(&MSR_MCG_CTL);
eval 'sub MSR_EVNTSEL0 () {0x186;}' unless defined(&MSR_EVNTSEL0);
eval 'sub MSR_EVNTSEL1 () {0x187;}' unless defined(&MSR_EVNTSEL1);
eval 'sub MSR_PERF_STATUS () {0x198;}' unless defined(&MSR_PERF_STATUS);
eval 'sub MSR_PERF_CTL () {0x199;}' unless defined(&MSR_PERF_CTL);
eval 'sub MSR_THERM_CONTROL () {0x19a;}' unless defined(&MSR_THERM_CONTROL);
eval 'sub MSR_THERM_INTERRUPT () {0x19b;}' unless defined(&MSR_THERM_INTERRUPT);
eval 'sub MSR_THERM_STATUS () {0x19c;}' unless defined(&MSR_THERM_STATUS);
eval 'sub MSR_THERM2_CTL () {0x19d;}' unless defined(&MSR_THERM2_CTL);
eval 'sub MSR_MISC_ENABLE () {0x1a0;}' unless defined(&MSR_MISC_ENABLE);
eval 'sub IA32_MISC_MWAIT_EN () {0x40000;}' unless defined(&IA32_MISC_MWAIT_EN);
eval 'sub MSR_TEMPERATURE_TARGET () {0x1a2;}' unless defined(&MSR_TEMPERATURE_TARGET);
eval 'sub MSR_DEBUGCTLMSR () {0x1d9;}' unless defined(&MSR_DEBUGCTLMSR);
eval 'sub MSR_LASTBRANCHFROMIP () {0x1db;}' unless defined(&MSR_LASTBRANCHFROMIP);
eval 'sub MSR_LASTBRANCHTOIP () {0x1dc;}' unless defined(&MSR_LASTBRANCHTOIP);
eval 'sub MSR_LASTINTFROMIP () {0x1dd;}' unless defined(&MSR_LASTINTFROMIP);
eval 'sub MSR_LASTINTTOIP () {0x1de;}' unless defined(&MSR_LASTINTTOIP);
eval 'sub MSR_ROB_CR_BKUPTMPDR6 () {0x1e0;}' unless defined(&MSR_ROB_CR_BKUPTMPDR6);
eval 'sub MSR_MTRRphysBase0 () {0x200;}' unless defined(&MSR_MTRRphysBase0);
eval 'sub MSR_MTRRphysMask0 () {0x201;}' unless defined(&MSR_MTRRphysMask0);
eval 'sub MSR_MTRRphysBase1 () {0x202;}' unless defined(&MSR_MTRRphysBase1);
eval 'sub MSR_MTRRphysMask1 () {0x203;}' unless defined(&MSR_MTRRphysMask1);
eval 'sub MSR_MTRRphysBase2 () {0x204;}' unless defined(&MSR_MTRRphysBase2);
eval 'sub MSR_MTRRphysMask2 () {0x205;}' unless defined(&MSR_MTRRphysMask2);
eval 'sub MSR_MTRRphysBase3 () {0x206;}' unless defined(&MSR_MTRRphysBase3);
eval 'sub MSR_MTRRphysMask3 () {0x207;}' unless defined(&MSR_MTRRphysMask3);
eval 'sub MSR_MTRRphysBase4 () {0x208;}' unless defined(&MSR_MTRRphysBase4);
eval 'sub MSR_MTRRphysMask4 () {0x209;}' unless defined(&MSR_MTRRphysMask4);
eval 'sub MSR_MTRRphysBase5 () {0x20a;}' unless defined(&MSR_MTRRphysBase5);
eval 'sub MSR_MTRRphysMask5 () {0x20b;}' unless defined(&MSR_MTRRphysMask5);
eval 'sub MSR_MTRRphysBase6 () {0x20c;}' unless defined(&MSR_MTRRphysBase6);
eval 'sub MSR_MTRRphysMask6 () {0x20d;}' unless defined(&MSR_MTRRphysMask6);
eval 'sub MSR_MTRRphysBase7 () {0x20e;}' unless defined(&MSR_MTRRphysBase7);
eval 'sub MSR_MTRRphysMask7 () {0x20f;}' unless defined(&MSR_MTRRphysMask7);
eval 'sub MSR_MTRRphysBase8 () {0x210;}' unless defined(&MSR_MTRRphysBase8);
eval 'sub MSR_MTRRphysMask8 () {0x211;}' unless defined(&MSR_MTRRphysMask8);
eval 'sub MSR_MTRRphysBase9 () {0x212;}' unless defined(&MSR_MTRRphysBase9);
eval 'sub MSR_MTRRphysMask9 () {0x213;}' unless defined(&MSR_MTRRphysMask9);
eval 'sub MSR_MTRRphysBase10 () {0x214;}' unless defined(&MSR_MTRRphysBase10);
eval 'sub MSR_MTRRphysMask10 () {0x215;}' unless defined(&MSR_MTRRphysMask10);
eval 'sub MSR_MTRRphysBase11 () {0x216;}' unless defined(&MSR_MTRRphysBase11);
eval 'sub MSR_MTRRphysMask11 () {0x217;}' unless defined(&MSR_MTRRphysMask11);
eval 'sub MSR_MTRRphysBase12 () {0x218;}' unless defined(&MSR_MTRRphysBase12);
eval 'sub MSR_MTRRphysMask12 () {0x219;}' unless defined(&MSR_MTRRphysMask12);
eval 'sub MSR_MTRRphysBase13 () {0x21a;}' unless defined(&MSR_MTRRphysBase13);
eval 'sub MSR_MTRRphysMask13 () {0x21b;}' unless defined(&MSR_MTRRphysMask13);
eval 'sub MSR_MTRRphysBase14 () {0x21c;}' unless defined(&MSR_MTRRphysBase14);
eval 'sub MSR_MTRRphysMask14 () {0x21d;}' unless defined(&MSR_MTRRphysMask14);
eval 'sub MSR_MTRRphysBase15 () {0x21e;}' unless defined(&MSR_MTRRphysBase15);
eval 'sub MSR_MTRRphysMask15 () {0x21f;}' unless defined(&MSR_MTRRphysMask15);
eval 'sub MSR_MTRRfix64K_00000 () {0x250;}' unless defined(&MSR_MTRRfix64K_00000);
eval 'sub MSR_MTRRfix16K_80000 () {0x258;}' unless defined(&MSR_MTRRfix16K_80000);
eval 'sub MSR_MTRRfix16K_A0000 () {0x259;}' unless defined(&MSR_MTRRfix16K_A0000);
eval 'sub MSR_MTRRfix4K_C0000 () {0x268;}' unless defined(&MSR_MTRRfix4K_C0000);
eval 'sub MSR_MTRRfix4K_C8000 () {0x269;}' unless defined(&MSR_MTRRfix4K_C8000);
eval 'sub MSR_MTRRfix4K_D0000 () {0x26a;}' unless defined(&MSR_MTRRfix4K_D0000);
eval 'sub MSR_MTRRfix4K_D8000 () {0x26b;}' unless defined(&MSR_MTRRfix4K_D8000);
eval 'sub MSR_MTRRfix4K_E0000 () {0x26c;}' unless defined(&MSR_MTRRfix4K_E0000);
eval 'sub MSR_MTRRfix4K_E8000 () {0x26d;}' unless defined(&MSR_MTRRfix4K_E8000);
eval 'sub MSR_MTRRfix4K_F0000 () {0x26e;}' unless defined(&MSR_MTRRfix4K_F0000);
eval 'sub MSR_MTRRfix4K_F8000 () {0x26f;}' unless defined(&MSR_MTRRfix4K_F8000);
eval 'sub MSR_CR_PAT () {0x277;}' unless defined(&MSR_CR_PAT);
eval 'sub MSR_MTRRdefType () {0x2ff;}' unless defined(&MSR_MTRRdefType);
eval 'sub MSR_MC0_CTL () {0x400;}' unless defined(&MSR_MC0_CTL);
eval 'sub MSR_MC0_STATUS () {0x401;}' unless defined(&MSR_MC0_STATUS);
eval 'sub MSR_MC0_ADDR () {0x402;}' unless defined(&MSR_MC0_ADDR);
eval 'sub MSR_MC0_MISC () {0x403;}' unless defined(&MSR_MC0_MISC);
eval 'sub MSR_MC1_CTL () {0x404;}' unless defined(&MSR_MC1_CTL);
eval 'sub MSR_MC1_STATUS () {0x405;}' unless defined(&MSR_MC1_STATUS);
eval 'sub MSR_MC1_ADDR () {0x406;}' unless defined(&MSR_MC1_ADDR);
eval 'sub MSR_MC1_MISC () {0x407;}' unless defined(&MSR_MC1_MISC);
eval 'sub MSR_MC2_CTL () {0x408;}' unless defined(&MSR_MC2_CTL);
eval 'sub MSR_MC2_STATUS () {0x409;}' unless defined(&MSR_MC2_STATUS);
eval 'sub MSR_MC2_ADDR () {0x40a;}' unless defined(&MSR_MC2_ADDR);
eval 'sub MSR_MC2_MISC () {0x40b;}' unless defined(&MSR_MC2_MISC);
eval 'sub MSR_MC3_CTL () {0x40c;}' unless defined(&MSR_MC3_CTL);
eval 'sub MSR_MC3_STATUS () {0x40d;}' unless defined(&MSR_MC3_STATUS);
eval 'sub MSR_MC3_ADDR () {0x40e;}' unless defined(&MSR_MC3_ADDR);
eval 'sub MSR_MC3_MISC () {0x40f;}' unless defined(&MSR_MC3_MISC);
eval 'sub MSR_MC4_CTL () {0x410;}' unless defined(&MSR_MC4_CTL);
eval 'sub MSR_MC4_STATUS () {0x411;}' unless defined(&MSR_MC4_STATUS);
eval 'sub MSR_MC4_ADDR () {0x412;}' unless defined(&MSR_MC4_ADDR);
eval 'sub MSR_MC4_MISC () {0x413;}' unless defined(&MSR_MC4_MISC);
eval 'sub MSR_X2APIC_BASE () {0x800;}' unless defined(&MSR_X2APIC_BASE);
eval 'sub MSR_X2APIC_ID () {0x2;}' unless defined(&MSR_X2APIC_ID);
eval 'sub MSR_X2APIC_VERS () {0x3;}' unless defined(&MSR_X2APIC_VERS);
eval 'sub MSR_X2APIC_TPRI () {0x8;}' unless defined(&MSR_X2APIC_TPRI);
eval 'sub MSR_X2APIC_PPRI () {0xa;}' unless defined(&MSR_X2APIC_PPRI);
eval 'sub MSR_X2APIC_EOI () {0xb;}' unless defined(&MSR_X2APIC_EOI);
eval 'sub MSR_X2APIC_LDR () {0xd;}' unless defined(&MSR_X2APIC_LDR);
eval 'sub MSR_X2APIC_SVR () {0xf;}' unless defined(&MSR_X2APIC_SVR);
eval 'sub MSR_X2APIC_ISR () {0x10;}' unless defined(&MSR_X2APIC_ISR);
eval 'sub MSR_X2APIC_TMR () {0x18;}' unless defined(&MSR_X2APIC_TMR);
eval 'sub MSR_X2APIC_IRR () {0x20;}' unless defined(&MSR_X2APIC_IRR);
eval 'sub MSR_X2APIC_ESR () {0x28;}' unless defined(&MSR_X2APIC_ESR);
eval 'sub MSR_X2APIC_LVT_CMCI () {0x2f;}' unless defined(&MSR_X2APIC_LVT_CMCI);
eval 'sub MSR_X2APIC_ICRLO () {0x30;}' unless defined(&MSR_X2APIC_ICRLO);
eval 'sub MSR_X2APIC_LVTT () {0x32;}' unless defined(&MSR_X2APIC_LVTT);
eval 'sub MSR_X2APIC_TMINT () {0x33;}' unless defined(&MSR_X2APIC_TMINT);
eval 'sub MSR_X2APIC_PCINT () {0x34;}' unless defined(&MSR_X2APIC_PCINT);
eval 'sub MSR_X2APIC_LVINT0 () {0x35;}' unless defined(&MSR_X2APIC_LVINT0);
eval 'sub MSR_X2APIC_LVINT1 () {0x36;}' unless defined(&MSR_X2APIC_LVINT1);
eval 'sub MSR_X2APIC_LVERR () {0x37;}' unless defined(&MSR_X2APIC_LVERR);
eval 'sub MSR_X2APIC_ICR_TIMER () {0x38;}' unless defined(&MSR_X2APIC_ICR_TIMER);
eval 'sub MSR_X2APIC_CCR_TIMER () {0x39;}' unless defined(&MSR_X2APIC_CCR_TIMER);
eval 'sub MSR_X2APIC_DCR_TIMER () {0x3e;}' unless defined(&MSR_X2APIC_DCR_TIMER);
eval 'sub MSR_X2APIC_SELF_IPI () {0x3f;}' unless defined(&MSR_X2APIC_SELF_IPI);
eval 'sub MSR_VIA_RNG () {0x110b;}' unless defined(&MSR_VIA_RNG);
eval 'sub MSR_VIA_RNG_ENABLE () {0x40;}' unless defined(&MSR_VIA_RNG_ENABLE);
eval 'sub MSR_VIA_RNG_NOISE_MASK () {0x300;}' unless defined(&MSR_VIA_RNG_NOISE_MASK);
eval 'sub MSR_VIA_RNG_NOISE_A () {0x;}' unless defined(&MSR_VIA_RNG_NOISE_A);
eval 'sub MSR_VIA_RNG_NOISE_B () {0x100;}' unless defined(&MSR_VIA_RNG_NOISE_B);
eval 'sub MSR_VIA_RNG_2NOISE () {0x300;}' unless defined(&MSR_VIA_RNG_2NOISE);
eval 'sub MSR_VIA_ACE () {0x1107;}' unless defined(&MSR_VIA_ACE);
eval 'sub MSR_VIA_ACE_ENABLE () {0x10000000;}' unless defined(&MSR_VIA_ACE_ENABLE);
eval 'sub MSR_VIA_FCR () { &MSR_VIA_ACE;}' unless defined(&MSR_VIA_FCR);
eval 'sub MSR_K6_UWCCR () {0xc0000085;}' unless defined(&MSR_K6_UWCCR);
eval 'sub MSR_K7_EVNTSEL0 () {0xc0010000;}' unless defined(&MSR_K7_EVNTSEL0);
eval 'sub MSR_K7_EVNTSEL1 () {0xc0010001;}' unless defined(&MSR_K7_EVNTSEL1);
eval 'sub MSR_K7_EVNTSEL2 () {0xc0010002;}' unless defined(&MSR_K7_EVNTSEL2);
eval 'sub MSR_K7_EVNTSEL3 () {0xc0010003;}' unless defined(&MSR_K7_EVNTSEL3);
eval 'sub MSR_K7_PERFCTR0 () {0xc0010004;}' unless defined(&MSR_K7_PERFCTR0);
eval 'sub MSR_K7_PERFCTR1 () {0xc0010005;}' unless defined(&MSR_K7_PERFCTR1);
eval 'sub MSR_K7_PERFCTR2 () {0xc0010006;}' unless defined(&MSR_K7_PERFCTR2);
eval 'sub MSR_K7_PERFCTR3 () {0xc0010007;}' unless defined(&MSR_K7_PERFCTR3);
eval 'sub MSR_SYSCFG () {0xc0010010;}' unless defined(&MSR_SYSCFG);
eval 'sub MSR_EFER () {0xc0000080;}' unless defined(&MSR_EFER);
eval 'sub EFER_SCE () {0x1;}' unless defined(&EFER_SCE);
eval 'sub EFER_LME () {0x100;}' unless defined(&EFER_LME);
eval 'sub EFER_LMA () {0x400;}' unless defined(&EFER_LMA);
eval 'sub EFER_NXE () {0x800;}' unless defined(&EFER_NXE);
eval 'sub EFER_SVME () {0x1000;}' unless defined(&EFER_SVME);
eval 'sub EFER_LMSLE () {0x2000;}' unless defined(&EFER_LMSLE);
eval 'sub EFER_FFXSR () {0x4000;}' unless defined(&EFER_FFXSR);
eval 'sub EFER_TCE () {0x8000;}' unless defined(&EFER_TCE);
eval 'sub MSR_STAR () {0xc0000081;}' unless defined(&MSR_STAR);
eval 'sub MSR_LSTAR () {0xc0000082;}' unless defined(&MSR_LSTAR);
eval 'sub MSR_CSTAR () {0xc0000083;}' unless defined(&MSR_CSTAR);
eval 'sub MSR_SFMASK () {0xc0000084;}' unless defined(&MSR_SFMASK);
eval 'sub MSR_FSBASE () {0xc0000100;}' unless defined(&MSR_FSBASE);
eval 'sub MSR_GSBASE () {0xc0000101;}' unless defined(&MSR_GSBASE);
eval 'sub MSR_KERNELGSBASE () {0xc0000102;}' unless defined(&MSR_KERNELGSBASE);
eval 'sub MSR_VMCR () {0xc0010114;}' unless defined(&MSR_VMCR);
eval 'sub VMCR_DPD () {0x1;}' unless defined(&VMCR_DPD);
eval 'sub VMCR_RINIT () {0x2;}' unless defined(&VMCR_RINIT);
eval 'sub VMCR_DISA20 () {0x4;}' unless defined(&VMCR_DISA20);
eval 'sub VMCR_LOCK () {0x8;}' unless defined(&VMCR_LOCK);
eval 'sub VMCR_SVMED () {0x10;}' unless defined(&VMCR_SVMED);
eval 'sub MSR_SVMLOCK () {0xc0010118;}' unless defined(&MSR_SVMLOCK);
eval 'sub MSR_HWCR () {0xc0010015;}' unless defined(&MSR_HWCR);
eval 'sub HWCR_TLBCACHEDIS () {0x8;}' unless defined(&HWCR_TLBCACHEDIS);
eval 'sub HWCR_FFDIS () {0x40;}' unless defined(&HWCR_FFDIS);
eval 'sub MSR_NB_CFG () {0xc001001f;}' unless defined(&MSR_NB_CFG);
eval 'sub NB_CFG_DISIOREQLOCK () {0x8;}' unless defined(&NB_CFG_DISIOREQLOCK);
eval 'sub NB_CFG_DISDATMSK () {0x1000000000;}' unless defined(&NB_CFG_DISDATMSK);
eval 'sub NB_CFG_INITAPICCPUIDLO () {(1 << 54);}' unless defined(&NB_CFG_INITAPICCPUIDLO);
eval 'sub MSR_LS_CFG () {0xc0011020;}' unless defined(&MSR_LS_CFG);
eval 'sub LS_CFG_DIS_LS2_SQUISH () {0x2000000;}' unless defined(&LS_CFG_DIS_LS2_SQUISH);
eval 'sub LS_CFG_DIS_SSB_F15H () {0x40000000000000;}' unless defined(&LS_CFG_DIS_SSB_F15H);
eval 'sub LS_CFG_DIS_SSB_F16H () {0x200000000;}' unless defined(&LS_CFG_DIS_SSB_F16H);
eval 'sub LS_CFG_DIS_SSB_F17H () {0x400;}' unless defined(&LS_CFG_DIS_SSB_F17H);
eval 'sub MSR_IC_CFG () {0xc0011021;}' unless defined(&MSR_IC_CFG);
eval 'sub IC_CFG_DIS_SEQ_PREFETCH () {0x800;}' unless defined(&IC_CFG_DIS_SEQ_PREFETCH);
eval 'sub IC_CFG_DIS_IND () {0x4000;}' unless defined(&IC_CFG_DIS_IND);
eval 'sub MSR_DC_CFG () {0xc0011022;}' unless defined(&MSR_DC_CFG);
eval 'sub DC_CFG_DIS_CNV_WC_SSO () {0x8;}' unless defined(&DC_CFG_DIS_CNV_WC_SSO);
eval 'sub DC_CFG_DIS_SMC_CHK_BUF () {0x400;}' unless defined(&DC_CFG_DIS_SMC_CHK_BUF);
eval 'sub DC_CFG_ERRATA_261 () {0x1000000;}' unless defined(&DC_CFG_ERRATA_261);
eval 'sub MSR_BU_CFG () {0xc0011023;}' unless defined(&MSR_BU_CFG);
eval 'sub BU_CFG_ERRATA_298 () {0x2;}' unless defined(&BU_CFG_ERRATA_298);
eval 'sub BU_CFG_ERRATA_254 () {0x200000;}' unless defined(&BU_CFG_ERRATA_254);
eval 'sub BU_CFG_ERRATA_309 () {0x800000;}' unless defined(&BU_CFG_ERRATA_309);
eval 'sub BU_CFG_THRL2IDXCMPDIS () {0x80000000000;}' unless defined(&BU_CFG_THRL2IDXCMPDIS);
eval 'sub BU_CFG_WBPFSMCCHKDIS () {0x200000000000;}' unless defined(&BU_CFG_WBPFSMCCHKDIS);
eval 'sub BU_CFG_WBENHWSBDIS () {0x1000000000000;}' unless defined(&BU_CFG_WBENHWSBDIS);
eval 'sub MSR_DE_CFG () {0xc0011029;}' unless defined(&MSR_DE_CFG);
eval 'sub DE_CFG_ERRATA_721 () {0x1;}' unless defined(&DE_CFG_ERRATA_721);
eval 'sub MSR_OSVW_ID_LENGTH () {0xc0010140;}' unless defined(&MSR_OSVW_ID_LENGTH);
eval 'sub MSR_OSVW_STATUS () {0xc0010141;}' unless defined(&MSR_OSVW_STATUS);
eval 'sub MSR_UCODE_AMD_PATCHLEVEL () {0x8b;}' unless defined(&MSR_UCODE_AMD_PATCHLEVEL);
eval 'sub MSR_UCODE_AMD_PATCHLOADER () {0xc0010020;}' unless defined(&MSR_UCODE_AMD_PATCHLOADER);
eval 'sub MSR_RDTSCP_AUX () {0xc0000103;}' unless defined(&MSR_RDTSCP_AUX);
eval 'sub MTRR_N64K () {8;}' unless defined(&MTRR_N64K);
eval 'sub MTRR_N16K () {16;}' unless defined(&MTRR_N16K);
eval 'sub MTRR_N4K () {64;}' unless defined(&MTRR_N4K);
eval 'sub NCR1 () {0xc4;}' unless defined(&NCR1);
eval 'sub NCR2 () {0xc7;}' unless defined(&NCR2);
eval 'sub NCR3 () {0xca;}' unless defined(&NCR3);
eval 'sub NCR4 () {0xcd;}' unless defined(&NCR4);
eval 'sub NCR_SIZE_0K () {0;}' unless defined(&NCR_SIZE_0K);
eval 'sub NCR_SIZE_4K () {1;}' unless defined(&NCR_SIZE_4K);
eval 'sub NCR_SIZE_8K () {2;}' unless defined(&NCR_SIZE_8K);
eval 'sub NCR_SIZE_16K () {3;}' unless defined(&NCR_SIZE_16K);
eval 'sub NCR_SIZE_32K () {4;}' unless defined(&NCR_SIZE_32K);
eval 'sub NCR_SIZE_64K () {5;}' unless defined(&NCR_SIZE_64K);
eval 'sub NCR_SIZE_128K () {6;}' unless defined(&NCR_SIZE_128K);
eval 'sub NCR_SIZE_256K () {7;}' unless defined(&NCR_SIZE_256K);
eval 'sub NCR_SIZE_512K () {8;}' unless defined(&NCR_SIZE_512K);
eval 'sub NCR_SIZE_1M () {9;}' unless defined(&NCR_SIZE_1M);
eval 'sub NCR_SIZE_2M () {10;}' unless defined(&NCR_SIZE_2M);
eval 'sub NCR_SIZE_4M () {11;}' unless defined(&NCR_SIZE_4M);
eval 'sub NCR_SIZE_8M () {12;}' unless defined(&NCR_SIZE_8M);
eval 'sub NCR_SIZE_16M () {13;}' unless defined(&NCR_SIZE_16M);
eval 'sub NCR_SIZE_32M () {14;}' unless defined(&NCR_SIZE_32M);
eval 'sub NCR_SIZE_4G () {15;}' unless defined(&NCR_SIZE_4G);
eval 'sub PMC5_CESR_EVENT () {0x3f;}' unless defined(&PMC5_CESR_EVENT);
eval 'sub PMC5_CESR_OS () {0x40;}' unless defined(&PMC5_CESR_OS);
eval 'sub PMC5_CESR_USR () {0x80;}' unless defined(&PMC5_CESR_USR);
eval 'sub PMC5_CESR_E () {0x100;}' unless defined(&PMC5_CESR_E);
eval 'sub PMC5_CESR_P () {0x200;}' unless defined(&PMC5_CESR_P);
eval 'sub PMC5_DATA_READ () {0x;}' unless defined(&PMC5_DATA_READ);
eval 'sub PMC5_DATA_WRITE () {0x1;}' unless defined(&PMC5_DATA_WRITE);
eval 'sub PMC5_DATA_TLB_MISS () {0x2;}' unless defined(&PMC5_DATA_TLB_MISS);
eval 'sub PMC5_DATA_READ_MISS () {0x3;}' unless defined(&PMC5_DATA_READ_MISS);
eval 'sub PMC5_DATA_WRITE_MISS () {0x4;}' unless defined(&PMC5_DATA_WRITE_MISS);
eval 'sub PMC5_WRITE_M_E () {0x5;}' unless defined(&PMC5_WRITE_M_E);
eval 'sub PMC5_DATA_LINES_WBACK () {0x6;}' unless defined(&PMC5_DATA_LINES_WBACK);
eval 'sub PMC5_DATA_CACHE_SNOOP () {0x7;}' unless defined(&PMC5_DATA_CACHE_SNOOP);
eval 'sub PMC5_DATA_CACHE_SNOOP_HIT () {0x8;}' unless defined(&PMC5_DATA_CACHE_SNOOP_HIT);
eval 'sub PMC5_MEM_ACCESS_BOTH_PIPES () {0x9;}' unless defined(&PMC5_MEM_ACCESS_BOTH_PIPES);
eval 'sub PMC5_BANK_CONFLICTS () {0xa;}' unless defined(&PMC5_BANK_CONFLICTS);
eval 'sub PMC5_MISALIGNED_DATA () {0xb;}' unless defined(&PMC5_MISALIGNED_DATA);
eval 'sub PMC5_INST_READ () {0xc;}' unless defined(&PMC5_INST_READ);
eval 'sub PMC5_INST_TLB_MISS () {0xd;}' unless defined(&PMC5_INST_TLB_MISS);
eval 'sub PMC5_INST_CACHE_MISS () {0xe;}' unless defined(&PMC5_INST_CACHE_MISS);
eval 'sub PMC5_SEGMENT_REG_LOAD () {0xf;}' unless defined(&PMC5_SEGMENT_REG_LOAD);
eval 'sub PMC5_BRANCHES () {0x12;}' unless defined(&PMC5_BRANCHES);
eval 'sub PMC5_BTB_HITS () {0x13;}' unless defined(&PMC5_BTB_HITS);
eval 'sub PMC5_BRANCH_TAKEN () {0x14;}' unless defined(&PMC5_BRANCH_TAKEN);
eval 'sub PMC5_PIPELINE_FLUSH () {0x15;}' unless defined(&PMC5_PIPELINE_FLUSH);
eval 'sub PMC5_INST_EXECUTED () {0x16;}' unless defined(&PMC5_INST_EXECUTED);
eval 'sub PMC5_INST_EXECUTED_V_PIPE () {0x17;}' unless defined(&PMC5_INST_EXECUTED_V_PIPE);
eval 'sub PMC5_BUS_UTILIZATION () {0x18;}' unless defined(&PMC5_BUS_UTILIZATION);
eval 'sub PMC5_WRITE_BACKUP_STALL () {0x19;}' unless defined(&PMC5_WRITE_BACKUP_STALL);
eval 'sub PMC5_DATA_READ_STALL () {0x1a;}' unless defined(&PMC5_DATA_READ_STALL);
eval 'sub PMC5_WRITE_E_M_STALL () {0x1b;}' unless defined(&PMC5_WRITE_E_M_STALL);
eval 'sub PMC5_LOCKED_BUS () {0x1c;}' unless defined(&PMC5_LOCKED_BUS);
eval 'sub PMC5_IO_CYCLE () {0x1d;}' unless defined(&PMC5_IO_CYCLE);
eval 'sub PMC5_NONCACHE_MEM_READ () {0x1e;}' unless defined(&PMC5_NONCACHE_MEM_READ);
eval 'sub PMC5_AGI_STALL () {0x1f;}' unless defined(&PMC5_AGI_STALL);
eval 'sub PMC5_FLOPS () {0x22;}' unless defined(&PMC5_FLOPS);
eval 'sub PMC5_BP0_MATCH () {0x23;}' unless defined(&PMC5_BP0_MATCH);
eval 'sub PMC5_BP1_MATCH () {0x24;}' unless defined(&PMC5_BP1_MATCH);
eval 'sub PMC5_BP2_MATCH () {0x25;}' unless defined(&PMC5_BP2_MATCH);
eval 'sub PMC5_BP3_MATCH () {0x26;}' unless defined(&PMC5_BP3_MATCH);
eval 'sub PMC5_HARDWARE_INTR () {0x27;}' unless defined(&PMC5_HARDWARE_INTR);
eval 'sub PMC5_DATA_RW () {0x28;}' unless defined(&PMC5_DATA_RW);
eval 'sub PMC5_DATA_RW_MISS () {0x29;}' unless defined(&PMC5_DATA_RW_MISS);
eval 'sub PMC6_EVTSEL_EVENT () {0xff;}' unless defined(&PMC6_EVTSEL_EVENT);
eval 'sub PMC6_EVTSEL_UNIT () {0xff00;}' unless defined(&PMC6_EVTSEL_UNIT);
eval 'sub PMC6_EVTSEL_UNIT_SHIFT () {8;}' unless defined(&PMC6_EVTSEL_UNIT_SHIFT);
eval 'sub PMC6_EVTSEL_USR () {(1<< 16);}' unless defined(&PMC6_EVTSEL_USR);
eval 'sub PMC6_EVTSEL_OS () {(1<< 17);}' unless defined(&PMC6_EVTSEL_OS);
eval 'sub PMC6_EVTSEL_E () {(1<< 18);}' unless defined(&PMC6_EVTSEL_E);
eval 'sub PMC6_EVTSEL_PC () {(1<< 19);}' unless defined(&PMC6_EVTSEL_PC);
eval 'sub PMC6_EVTSEL_INT () {(1<< 20);}' unless defined(&PMC6_EVTSEL_INT);
eval 'sub PMC6_EVTSEL_EN () {(1<< 22);}' unless defined(&PMC6_EVTSEL_EN);
eval 'sub PMC6_EVTSEL_INV () {(1<< 23);}' unless defined(&PMC6_EVTSEL_INV);
eval 'sub PMC6_EVTSEL_COUNTER_MASK () {0xff000000;}' unless defined(&PMC6_EVTSEL_COUNTER_MASK);
eval 'sub PMC6_EVTSEL_COUNTER_MASK_SHIFT () {24;}' unless defined(&PMC6_EVTSEL_COUNTER_MASK_SHIFT);
eval 'sub PMC6_DATA_MEM_REFS () {0x43;}' unless defined(&PMC6_DATA_MEM_REFS);
eval 'sub PMC6_DCU_LINES_IN () {0x45;}' unless defined(&PMC6_DCU_LINES_IN);
eval 'sub PMC6_DCU_M_LINES_IN () {0x46;}' unless defined(&PMC6_DCU_M_LINES_IN);
eval 'sub PMC6_DCU_M_LINES_OUT () {0x47;}' unless defined(&PMC6_DCU_M_LINES_OUT);
eval 'sub PMC6_DCU_MISS_OUTSTANDING () {0x48;}' unless defined(&PMC6_DCU_MISS_OUTSTANDING);
eval 'sub PMC6_IFU_IFETCH () {0x80;}' unless defined(&PMC6_IFU_IFETCH);
eval 'sub PMC6_IFU_IFETCH_MISS () {0x81;}' unless defined(&PMC6_IFU_IFETCH_MISS);
eval 'sub PMC6_ITLB_MISS () {0x85;}' unless defined(&PMC6_ITLB_MISS);
eval 'sub PMC6_IFU_MEM_STALL () {0x86;}' unless defined(&PMC6_IFU_MEM_STALL);
eval 'sub PMC6_ILD_STALL () {0x87;}' unless defined(&PMC6_ILD_STALL);
eval 'sub PMC6_L2_IFETCH () {0x28;}' unless defined(&PMC6_L2_IFETCH);
eval 'sub PMC6_L2_LD () {0x29;}' unless defined(&PMC6_L2_LD);
eval 'sub PMC6_L2_ST () {0x2a;}' unless defined(&PMC6_L2_ST);
eval 'sub PMC6_L2_LINES_IN () {0x24;}' unless defined(&PMC6_L2_LINES_IN);
eval 'sub PMC6_L2_LINES_OUT () {0x26;}' unless defined(&PMC6_L2_LINES_OUT);
eval 'sub PMC6_L2_M_LINES_INM () {0x25;}' unless defined(&PMC6_L2_M_LINES_INM);
eval 'sub PMC6_L2_M_LINES_OUTM () {0x27;}' unless defined(&PMC6_L2_M_LINES_OUTM);
eval 'sub PMC6_L2_RQSTS () {0x2e;}' unless defined(&PMC6_L2_RQSTS);
eval 'sub PMC6_L2_ADS () {0x21;}' unless defined(&PMC6_L2_ADS);
eval 'sub PMC6_L2_DBUS_BUSY () {0x22;}' unless defined(&PMC6_L2_DBUS_BUSY);
eval 'sub PMC6_L2_DBUS_BUSY_RD () {0x23;}' unless defined(&PMC6_L2_DBUS_BUSY_RD);
eval 'sub PMC6_BUS_DRDY_CLOCKS () {0x62;}' unless defined(&PMC6_BUS_DRDY_CLOCKS);
eval 'sub PMC6_BUS_LOCK_CLOCKS () {0x63;}' unless defined(&PMC6_BUS_LOCK_CLOCKS);
eval 'sub PMC6_BUS_REQ_OUTSTANDING () {0x60;}' unless defined(&PMC6_BUS_REQ_OUTSTANDING);
eval 'sub PMC6_BUS_TRAN_BRD () {0x65;}' unless defined(&PMC6_BUS_TRAN_BRD);
eval 'sub PMC6_BUS_TRAN_RFO () {0x66;}' unless defined(&PMC6_BUS_TRAN_RFO);
eval 'sub PMC6_BUS_TRANS_WB () {0x67;}' unless defined(&PMC6_BUS_TRANS_WB);
eval 'sub PMC6_BUS_TRAN_IFETCH () {0x68;}' unless defined(&PMC6_BUS_TRAN_IFETCH);
eval 'sub PMC6_BUS_TRAN_INVAL () {0x69;}' unless defined(&PMC6_BUS_TRAN_INVAL);
eval 'sub PMC6_BUS_TRAN_PWR () {0x6a;}' unless defined(&PMC6_BUS_TRAN_PWR);
eval 'sub PMC6_BUS_TRANS_P () {0x6b;}' unless defined(&PMC6_BUS_TRANS_P);
eval 'sub PMC6_BUS_TRANS_IO () {0x6c;}' unless defined(&PMC6_BUS_TRANS_IO);
eval 'sub PMC6_BUS_TRAN_DEF () {0x6d;}' unless defined(&PMC6_BUS_TRAN_DEF);
eval 'sub PMC6_BUS_TRAN_BURST () {0x6e;}' unless defined(&PMC6_BUS_TRAN_BURST);
eval 'sub PMC6_BUS_TRAN_ANY () {0x70;}' unless defined(&PMC6_BUS_TRAN_ANY);
eval 'sub PMC6_BUS_TRAN_MEM () {0x6f;}' unless defined(&PMC6_BUS_TRAN_MEM);
eval 'sub PMC6_BUS_DATA_RCV () {0x64;}' unless defined(&PMC6_BUS_DATA_RCV);
eval 'sub PMC6_BUS_BNR_DRV () {0x61;}' unless defined(&PMC6_BUS_BNR_DRV);
eval 'sub PMC6_BUS_HIT_DRV () {0x7a;}' unless defined(&PMC6_BUS_HIT_DRV);
eval 'sub PMC6_BUS_HITM_DRDV () {0x7b;}' unless defined(&PMC6_BUS_HITM_DRDV);
eval 'sub PMC6_BUS_SNOOP_STALL () {0x7e;}' unless defined(&PMC6_BUS_SNOOP_STALL);
eval 'sub PMC6_FLOPS () {0xc1;}' unless defined(&PMC6_FLOPS);
eval 'sub PMC6_FP_COMP_OPS_EXE () {0x10;}' unless defined(&PMC6_FP_COMP_OPS_EXE);
eval 'sub PMC6_FP_ASSIST () {0x11;}' unless defined(&PMC6_FP_ASSIST);
eval 'sub PMC6_MUL () {0x12;}' unless defined(&PMC6_MUL);
eval 'sub PMC6_DIV () {0x12;}' unless defined(&PMC6_DIV);
eval 'sub PMC6_CYCLES_DIV_BUSY () {0x14;}' unless defined(&PMC6_CYCLES_DIV_BUSY);
eval 'sub PMC6_LD_BLOCKS () {0x3;}' unless defined(&PMC6_LD_BLOCKS);
eval 'sub PMC6_SB_DRAINS () {0x4;}' unless defined(&PMC6_SB_DRAINS);
eval 'sub PMC6_MISALIGN_MEM_REF () {0x5;}' unless defined(&PMC6_MISALIGN_MEM_REF);
eval 'sub PMC6_EMON_KNI_PREF_DISPATCHED () {0x7;}' unless defined(&PMC6_EMON_KNI_PREF_DISPATCHED);
eval 'sub PMC6_EMON_KNI_PREF_MISS () {0x4b;}' unless defined(&PMC6_EMON_KNI_PREF_MISS);
eval 'sub PMC6_INST_RETIRED () {0xc0;}' unless defined(&PMC6_INST_RETIRED);
eval 'sub PMC6_UOPS_RETIRED () {0xc2;}' unless defined(&PMC6_UOPS_RETIRED);
eval 'sub PMC6_INST_DECODED () {0xd0;}' unless defined(&PMC6_INST_DECODED);
eval 'sub PMC6_EMON_KNI_INST_RETIRED () {0xd8;}' unless defined(&PMC6_EMON_KNI_INST_RETIRED);
eval 'sub PMC6_EMON_KNI_COMP_INST_RET () {0xd9;}' unless defined(&PMC6_EMON_KNI_COMP_INST_RET);
eval 'sub PMC6_HW_INT_RX () {0xc8;}' unless defined(&PMC6_HW_INT_RX);
eval 'sub PMC6_CYCLES_INT_MASKED () {0xc6;}' unless defined(&PMC6_CYCLES_INT_MASKED);
eval 'sub PMC6_CYCLES_INT_PENDING_AND_MASKED () {0xc7;}' unless defined(&PMC6_CYCLES_INT_PENDING_AND_MASKED);
eval 'sub PMC6_BR_INST_RETIRED () {0xc4;}' unless defined(&PMC6_BR_INST_RETIRED);
eval 'sub PMC6_BR_MISS_PRED_RETIRED () {0xc5;}' unless defined(&PMC6_BR_MISS_PRED_RETIRED);
eval 'sub PMC6_BR_TAKEN_RETIRED () {0xc9;}' unless defined(&PMC6_BR_TAKEN_RETIRED);
eval 'sub PMC6_BR_MISS_PRED_TAKEN_RET () {0xca;}' unless defined(&PMC6_BR_MISS_PRED_TAKEN_RET);
eval 'sub PMC6_BR_INST_DECODED () {0xe0;}' unless defined(&PMC6_BR_INST_DECODED);
eval 'sub PMC6_BTB_MISSES () {0xe2;}' unless defined(&PMC6_BTB_MISSES);
eval 'sub PMC6_BR_BOGUS () {0xe4;}' unless defined(&PMC6_BR_BOGUS);
eval 'sub PMC6_BACLEARS () {0xe6;}' unless defined(&PMC6_BACLEARS);
eval 'sub PMC6_RESOURCE_STALLS () {0xa2;}' unless defined(&PMC6_RESOURCE_STALLS);
eval 'sub PMC6_PARTIAL_RAT_STALLS () {0xd2;}' unless defined(&PMC6_PARTIAL_RAT_STALLS);
eval 'sub PMC6_SEGMENT_REG_LOADS () {0x6;}' unless defined(&PMC6_SEGMENT_REG_LOADS);
eval 'sub PMC6_CPU_CLK_UNHALTED () {0x79;}' unless defined(&PMC6_CPU_CLK_UNHALTED);
eval 'sub PMC6_MMX_INSTR_EXEC () {0xb0;}' unless defined(&PMC6_MMX_INSTR_EXEC);
eval 'sub PMC6_MMX_SAT_INSTR_EXEC () {0xb1;}' unless defined(&PMC6_MMX_SAT_INSTR_EXEC);
eval 'sub PMC6_MMX_UOPS_EXEC () {0xb2;}' unless defined(&PMC6_MMX_UOPS_EXEC);
eval 'sub PMC6_MMX_INSTR_TYPE_EXEC () {0xb3;}' unless defined(&PMC6_MMX_INSTR_TYPE_EXEC);
eval 'sub PMC6_FP_MMX_TRANS () {0xcc;}' unless defined(&PMC6_FP_MMX_TRANS);
eval 'sub PMC6_MMX_ASSIST () {0xcd;}' unless defined(&PMC6_MMX_ASSIST);
eval 'sub PMC6_MMX_INSTR_RET () {0xc3;}' unless defined(&PMC6_MMX_INSTR_RET);
eval 'sub PMC6_SEG_RENAME_STALLS () {0xd4;}' unless defined(&PMC6_SEG_RENAME_STALLS);
eval 'sub PMC6_SEG_REG_RENAMES () {0xd5;}' unless defined(&PMC6_SEG_REG_RENAMES);
eval 'sub PMC6_RET_SEG_RENAMES () {0xd6;}' unless defined(&PMC6_RET_SEG_RENAMES);
eval 'sub K7_EVTSEL_EVENT () {0xff;}' unless defined(&K7_EVTSEL_EVENT);
eval 'sub K7_EVTSEL_UNIT () {0xff00;}' unless defined(&K7_EVTSEL_UNIT);
eval 'sub K7_EVTSEL_UNIT_SHIFT () {8;}' unless defined(&K7_EVTSEL_UNIT_SHIFT);
eval 'sub K7_EVTSEL_USR () { &__BIT(16);}' unless defined(&K7_EVTSEL_USR);
eval 'sub K7_EVTSEL_OS () { &__BIT(17);}' unless defined(&K7_EVTSEL_OS);
eval 'sub K7_EVTSEL_E () { &__BIT(18);}' unless defined(&K7_EVTSEL_E);
eval 'sub K7_EVTSEL_PC () { &__BIT(19);}' unless defined(&K7_EVTSEL_PC);
eval 'sub K7_EVTSEL_INT () { &__BIT(20);}' unless defined(&K7_EVTSEL_INT);
eval 'sub K7_EVTSEL_EN () { &__BIT(22);}' unless defined(&K7_EVTSEL_EN);
eval 'sub K7_EVTSEL_INV () { &__BIT(23);}' unless defined(&K7_EVTSEL_INV);
eval 'sub K7_EVTSEL_COUNTER_MASK () {0xff000000;}' unless defined(&K7_EVTSEL_COUNTER_MASK);
eval 'sub K7_EVTSEL_COUNTER_MASK_SHIFT () {24;}' unless defined(&K7_EVTSEL_COUNTER_MASK_SHIFT);
eval 'sub K7_DATA_CACHE_ACCESS () {0x40;}' unless defined(&K7_DATA_CACHE_ACCESS);
eval 'sub K7_DATA_CACHE_MISS () {0x41;}' unless defined(&K7_DATA_CACHE_MISS);
eval 'sub K7_DATA_CACHE_REFILL () {0x42;}' unless defined(&K7_DATA_CACHE_REFILL);
eval 'sub K7_DATA_CACHE_REFILL_SYSTEM () {0x43;}' unless defined(&K7_DATA_CACHE_REFILL_SYSTEM);
eval 'sub K7_DATA_CACHE_WBACK () {0x44;}' unless defined(&K7_DATA_CACHE_WBACK);
eval 'sub K7_L1_DTLB_MISS () {0x45;}' unless defined(&K7_L1_DTLB_MISS);
eval 'sub K7_L2_DTLB_MISS () {0x46;}' unless defined(&K7_L2_DTLB_MISS);
eval 'sub K7_MISALIGNED_DATA_REF () {0x47;}' unless defined(&K7_MISALIGNED_DATA_REF);
eval 'sub K7_IFU_IFETCH () {0x80;}' unless defined(&K7_IFU_IFETCH);
eval 'sub K7_IFU_IFETCH_MISS () {0x81;}' unless defined(&K7_IFU_IFETCH_MISS);
eval 'sub K7_IFU_REFILL_FROM_L2 () {0x82;}' unless defined(&K7_IFU_REFILL_FROM_L2);
eval 'sub K7_IFU_REFILL_FROM_SYSTEM () {0x83;}' unless defined(&K7_IFU_REFILL_FROM_SYSTEM);
eval 'sub K7_L1_ITLB_MISS () {0x84;}' unless defined(&K7_L1_ITLB_MISS);
eval 'sub K7_L2_ITLB_MISS () {0x85;}' unless defined(&K7_L2_ITLB_MISS);
eval 'sub K7_RETIRED_INST () {0xc0;}' unless defined(&K7_RETIRED_INST);
eval 'sub K7_RETIRED_OPS () {0xc1;}' unless defined(&K7_RETIRED_OPS);
eval 'sub K7_RETIRED_BRANCH () {0xc2;}' unless defined(&K7_RETIRED_BRANCH);
eval 'sub K7_RETIRED_BRANCH_MISPREDICTED () {0xc3;}' unless defined(&K7_RETIRED_BRANCH_MISPREDICTED);
eval 'sub K7_RETIRED_TAKEN_BRANCH () {0xc4;}' unless defined(&K7_RETIRED_TAKEN_BRANCH);
eval 'sub K7_RETIRED_TAKEN_BRANCH_MISPREDICTED () {0xc5;}' unless defined(&K7_RETIRED_TAKEN_BRANCH_MISPREDICTED);
eval 'sub K7_RETIRED_FAR_CONTROL_TRANSFER () {0xc6;}' unless defined(&K7_RETIRED_FAR_CONTROL_TRANSFER);
eval 'sub K7_RETIRED_RESYNC_BRANCH () {0xc7;}' unless defined(&K7_RETIRED_RESYNC_BRANCH);
eval 'sub K7_CYCLES_INT_MASKED () {0xcd;}' unless defined(&K7_CYCLES_INT_MASKED);
eval 'sub K7_CYCLES_INT_PENDING_AND_MASKED () {0xce;}' unless defined(&K7_CYCLES_INT_PENDING_AND_MASKED);
eval 'sub K7_HW_INTR_RECV () {0xcf;}' unless defined(&K7_HW_INTR_RECV);
eval 'sub MSR_F10H_EVNTSEL0 () {0xc0010000;}' unless defined(&MSR_F10H_EVNTSEL0);
eval 'sub MSR_F10H_EVNTSEL1 () {0xc0010001;}' unless defined(&MSR_F10H_EVNTSEL1);
eval 'sub MSR_F10H_EVNTSEL2 () {0xc0010002;}' unless defined(&MSR_F10H_EVNTSEL2);
eval 'sub MSR_F10H_EVNTSEL3 () {0xc0010003;}' unless defined(&MSR_F10H_EVNTSEL3);
eval 'sub MSR_F10H_PERFCTR0 () {0xc0010004;}' unless defined(&MSR_F10H_PERFCTR0);
eval 'sub MSR_F10H_PERFCTR1 () {0xc0010005;}' unless defined(&MSR_F10H_PERFCTR1);
eval 'sub MSR_F10H_PERFCTR2 () {0xc0010006;}' unless defined(&MSR_F10H_PERFCTR2);
eval 'sub MSR_F10H_PERFCTR3 () {0xc0010007;}' unless defined(&MSR_F10H_PERFCTR3);
eval 'sub F10H_EVTSEL_EVENT_MASK () {0xf000000ff;}' unless defined(&F10H_EVTSEL_EVENT_MASK);
eval 'sub F10H_EVTSEL_EVENT_SHIFT_LOW () {0;}' unless defined(&F10H_EVTSEL_EVENT_SHIFT_LOW);
eval 'sub F10H_EVTSEL_EVENT_SHIFT_HIGH () {32;}' unless defined(&F10H_EVTSEL_EVENT_SHIFT_HIGH);
eval 'sub F10H_EVTSEL_UNIT_MASK () {0xff00;}' unless defined(&F10H_EVTSEL_UNIT_MASK);
eval 'sub F10H_EVTSEL_UNIT_SHIFT () {8;}' unless defined(&F10H_EVTSEL_UNIT_SHIFT);
eval 'sub F10H_EVTSEL_USR () { &__BIT(16);}' unless defined(&F10H_EVTSEL_USR);
eval 'sub F10H_EVTSEL_OS () { &__BIT(17);}' unless defined(&F10H_EVTSEL_OS);
eval 'sub F10H_EVTSEL_EDGE () { &__BIT(18);}' unless defined(&F10H_EVTSEL_EDGE);
eval 'sub F10H_EVTSEL_RSVD1 () { &__BIT(19);}' unless defined(&F10H_EVTSEL_RSVD1);
eval 'sub F10H_EVTSEL_INT () { &__BIT(20);}' unless defined(&F10H_EVTSEL_INT);
eval 'sub F10H_EVTSEL_RSVD2 () { &__BIT(21);}' unless defined(&F10H_EVTSEL_RSVD2);
eval 'sub F10H_EVTSEL_EN () { &__BIT(22);}' unless defined(&F10H_EVTSEL_EN);
eval 'sub F10H_EVTSEL_INV () { &__BIT(23);}' unless defined(&F10H_EVTSEL_INV);
eval 'sub F10H_EVTSEL_COUNTER_MASK () {0xff000000;}' unless defined(&F10H_EVTSEL_COUNTER_MASK);
eval 'sub F10H_EVTSEL_COUNTER_MASK_SHIFT () {24;}' unless defined(&F10H_EVTSEL_COUNTER_MASK_SHIFT);
eval 'sub F10H_FP_DISPATCHED_FPU_OPS () {0x;}' unless defined(&F10H_FP_DISPATCHED_FPU_OPS);
eval 'sub F10H_FP_CYCLES_EMPTY_FPU_OPS () {0x1;}' unless defined(&F10H_FP_CYCLES_EMPTY_FPU_OPS);
eval 'sub F10H_FP_DISPATCHED_FASTFLAG_OPS () {0x2;}' unless defined(&F10H_FP_DISPATCHED_FASTFLAG_OPS);
eval 'sub F10H_FP_RETIRED_SSE_OPS () {0x3;}' unless defined(&F10H_FP_RETIRED_SSE_OPS);
eval 'sub F10H_FP_RETIRED_MOVE_OPS () {0x4;}' unless defined(&F10H_FP_RETIRED_MOVE_OPS);
eval 'sub F10H_FP_RETIRED_SERIALIZING_OPS () {0x5;}' unless defined(&F10H_FP_RETIRED_SERIALIZING_OPS);
eval 'sub F10H_FP_CYCLES_SERIALIZING_OP_SCHEDULER () {0x6;}' unless defined(&F10H_FP_CYCLES_SERIALIZING_OP_SCHEDULER);
eval 'sub F10H_SEGMENT_REG_LOADS () {0x20;}' unless defined(&F10H_SEGMENT_REG_LOADS);
eval 'sub F10H_PIPELINE_RESTART_SELFMOD_CODE () {0x21;}' unless defined(&F10H_PIPELINE_RESTART_SELFMOD_CODE);
eval 'sub F10H_PIPELINE_RESTART_PROBE_HIT () {0x22;}' unless defined(&F10H_PIPELINE_RESTART_PROBE_HIT);
eval 'sub F10H_LS_BUFFER_2_FILL () {0x23;}' unless defined(&F10H_LS_BUFFER_2_FILL);
eval 'sub F10H_LOCKED_OPERATIONS () {0x24;}' unless defined(&F10H_LOCKED_OPERATIONS);
eval 'sub F10H_RETIRED_CLFLUSH_INSTRUCTIONS () {0x26;}' unless defined(&F10H_RETIRED_CLFLUSH_INSTRUCTIONS);
eval 'sub F10H_RETIRED_CPUID_INSTRUCTIONS () {0x27;}' unless defined(&F10H_RETIRED_CPUID_INSTRUCTIONS);
eval 'sub F10H_CANCELLED_STORE_LOAD_FORWARD_OPS () {0x2a;}' unless defined(&F10H_CANCELLED_STORE_LOAD_FORWARD_OPS);
eval 'sub F10H_SMI_RECEIVED () {0x2b;}' unless defined(&F10H_SMI_RECEIVED);
eval 'sub F10H_DATA_CACHE_ACCESS () {0x40;}' unless defined(&F10H_DATA_CACHE_ACCESS);
eval 'sub F10H_DATA_CACHE_MISS () {0x41;}' unless defined(&F10H_DATA_CACHE_MISS);
eval 'sub F10H_DATA_CACHE_REFILL_FROM_L2 () {0x42;}' unless defined(&F10H_DATA_CACHE_REFILL_FROM_L2);
eval 'sub F10H_DATA_CACHE_REFILL_FROM_NORTHBRIDGE () {0x43;}' unless defined(&F10H_DATA_CACHE_REFILL_FROM_NORTHBRIDGE);
eval 'sub F10H_CACHE_LINES_EVICTED () {0x44;}' unless defined(&F10H_CACHE_LINES_EVICTED);
eval 'sub F10H_L1_DTLB_MISS () {0x45;}' unless defined(&F10H_L1_DTLB_MISS);
eval 'sub F10H_L2_DTLB_MISS () {0x46;}' unless defined(&F10H_L2_DTLB_MISS);
eval 'sub F10H_MISALIGNED_ACCESS () {0x47;}' unless defined(&F10H_MISALIGNED_ACCESS);
eval 'sub F10H_MICROARCH_LATE_CANCEL_OF_ACCESS () {0x48;}' unless defined(&F10H_MICROARCH_LATE_CANCEL_OF_ACCESS);
eval 'sub F10H_MICROARCH_EARLY_CANCEL_OF_ACCESS () {0x49;}' unless defined(&F10H_MICROARCH_EARLY_CANCEL_OF_ACCESS);
eval 'sub F10H_SINGLE_BIT_ECC_ERRORS_RECORDED () {0x4a;}' unless defined(&F10H_SINGLE_BIT_ECC_ERRORS_RECORDED);
eval 'sub F10H_PREFETCH_INSTRUCTIONS_DISPATCHED () {0x4b;}' unless defined(&F10H_PREFETCH_INSTRUCTIONS_DISPATCHED);
eval 'sub F10H_DCACHE_MISSES_LOCKED_INSTRUCTIONS () {0x4c;}' unless defined(&F10H_DCACHE_MISSES_LOCKED_INSTRUCTIONS);
eval 'sub F10H_L1_DTLB_HIT () {0x4d;}' unless defined(&F10H_L1_DTLB_HIT);
eval 'sub F10H_INEFFECTIVE_SOFTWARE_PREFETCHS () {0x52;}' unless defined(&F10H_INEFFECTIVE_SOFTWARE_PREFETCHS);
eval 'sub F10H_GLOBAL_TLB_FLUSHES () {0x54;}' unless defined(&F10H_GLOBAL_TLB_FLUSHES);
eval 'sub F10H_MEMORY_REQUESTS_BY_TYPE () {0x65;}' unless defined(&F10H_MEMORY_REQUESTS_BY_TYPE);
eval 'sub F10H_DATA_PREFETCHER () {0x67;}' unless defined(&F10H_DATA_PREFETCHER);
eval 'sub F10H_MAB_REQUESTS () {0x68;}' unless defined(&F10H_MAB_REQUESTS);
eval 'sub F10H_MAB_WAIT_CYCLES () {0x69;}' unless defined(&F10H_MAB_WAIT_CYCLES);
eval 'sub F10H_NORTHBRIDGE_READ_RESP_BY_COH_STATE () {0x6c;}' unless defined(&F10H_NORTHBRIDGE_READ_RESP_BY_COH_STATE);
eval 'sub F10H_OCTWORDS_WRITTEN_TO_SYSTEM () {0x6d;}' unless defined(&F10H_OCTWORDS_WRITTEN_TO_SYSTEM);
eval 'sub F10H_CPU_CLOCKS_NOT_HALTED () {0x76;}' unless defined(&F10H_CPU_CLOCKS_NOT_HALTED);
eval 'sub F10H_REQUESTS_TO_L2_CACHE () {0x7d;}' unless defined(&F10H_REQUESTS_TO_L2_CACHE);
eval 'sub F10H_L2_CACHE_MISSES () {0x7e;}' unless defined(&F10H_L2_CACHE_MISSES);
eval 'sub F10H_L2_FILL () {0x7f;}' unless defined(&F10H_L2_FILL);
eval 'sub F10H_INSTRUCTION_CACHE_FETCH () {0x80;}' unless defined(&F10H_INSTRUCTION_CACHE_FETCH);
eval 'sub F10H_INSTRUCTION_CACHE_MISS () {0x81;}' unless defined(&F10H_INSTRUCTION_CACHE_MISS);
eval 'sub F10H_INSTRUCTION_CACHE_REFILL_FROM_L2 () {0x82;}' unless defined(&F10H_INSTRUCTION_CACHE_REFILL_FROM_L2);
eval 'sub F10H_INSTRUCTION_CACHE_REFILL_FROM_SYS () {0x83;}' unless defined(&F10H_INSTRUCTION_CACHE_REFILL_FROM_SYS);
eval 'sub F10H_L1_ITLB_MISS () {0x84;}' unless defined(&F10H_L1_ITLB_MISS);
eval 'sub F10H_L2_ITLB_MISS () {0x85;}' unless defined(&F10H_L2_ITLB_MISS);
eval 'sub F10H_PIPELINE_RESTART_INSTR_STREAM_PROBE () {0x86;}' unless defined(&F10H_PIPELINE_RESTART_INSTR_STREAM_PROBE);
eval 'sub F10H_INSTRUCTION_FETCH_STALL () {0x87;}' unless defined(&F10H_INSTRUCTION_FETCH_STALL);
eval 'sub F10H_RETURN_STACK_HITS () {0x88;}' unless defined(&F10H_RETURN_STACK_HITS);
eval 'sub F10H_RETURN_STACK_OVERFLOWS () {0x89;}' unless defined(&F10H_RETURN_STACK_OVERFLOWS);
eval 'sub F10H_INSTRUCTION_CACHE_VICTIMS () {0x8b;}' unless defined(&F10H_INSTRUCTION_CACHE_VICTIMS);
eval 'sub F10H_INSTRUCTION_CACHE_LINES_INVALIDATED () {0x8c;}' unless defined(&F10H_INSTRUCTION_CACHE_LINES_INVALIDATED);
eval 'sub F10H_ITLD_RELOADS () {0x99;}' unless defined(&F10H_ITLD_RELOADS);
eval 'sub F10H_ITLD_RELOADS_ABORTED () {0x9a;}' unless defined(&F10H_ITLD_RELOADS_ABORTED);
eval 'sub F10H_RETIRED_INSTRUCTIONS () {0xc0;}' unless defined(&F10H_RETIRED_INSTRUCTIONS);
eval 'sub F10H_RETIRED_UOPS () {0xc1;}' unless defined(&F10H_RETIRED_UOPS);
eval 'sub F10H_RETIRED_BRANCH () {0xc2;}' unless defined(&F10H_RETIRED_BRANCH);
eval 'sub F10H_RETIRED_MISPREDICTED_BRANCH () {0xc3;}' unless defined(&F10H_RETIRED_MISPREDICTED_BRANCH);
eval 'sub F10H_RETIRED_TAKEN_BRANCH () {0xc4;}' unless defined(&F10H_RETIRED_TAKEN_BRANCH);
eval 'sub F10H_RETIRED_TAKEN_BRANCH_MISPREDICTED () {0xc5;}' unless defined(&F10H_RETIRED_TAKEN_BRANCH_MISPREDICTED);
eval 'sub F10H_RETIRED_FAR_CONTROL_TRANSFER () {0xc6;}' unless defined(&F10H_RETIRED_FAR_CONTROL_TRANSFER);
eval 'sub F10H_RETIRED_BRANCH_RESYNC () {0xc7;}' unless defined(&F10H_RETIRED_BRANCH_RESYNC);
eval 'sub F10H_RETIRED_NEAR_RETURNS () {0xc8;}' unless defined(&F10H_RETIRED_NEAR_RETURNS);
eval 'sub F10H_RETIRED_NEAR_RETURNS_MISPREDICTED () {0xc9;}' unless defined(&F10H_RETIRED_NEAR_RETURNS_MISPREDICTED);
eval 'sub F10H_RETIRED_INDIRECT_BRANCH_MISPREDICTED () {0xca;}' unless defined(&F10H_RETIRED_INDIRECT_BRANCH_MISPREDICTED);
eval 'sub F10H_RETIRED_MMX_FP_INSTRUCTIONS () {0xcb;}' unless defined(&F10H_RETIRED_MMX_FP_INSTRUCTIONS);
eval 'sub F10H_RETIRED_FASTPATH_DOUBLE_OP_INSTR () {0xcc;}' unless defined(&F10H_RETIRED_FASTPATH_DOUBLE_OP_INSTR);
eval 'sub F10H_INTERRUPTS_MASKED_CYCLES () {0xcd;}' unless defined(&F10H_INTERRUPTS_MASKED_CYCLES);
eval 'sub F10H_INTERRUPTS_MASKED_CYCLES_INTERRUPT_PENDING () {0xce;}' unless defined(&F10H_INTERRUPTS_MASKED_CYCLES_INTERRUPT_PENDING);
eval 'sub F10H_INTERRUPTS_TAKEN () {0xcf;}' unless defined(&F10H_INTERRUPTS_TAKEN);
eval 'sub F10H_DECODER_EMPTY () {0xd0;}' unless defined(&F10H_DECODER_EMPTY);
eval 'sub F10H_DISPATCH_STALLS () {0xd1;}' unless defined(&F10H_DISPATCH_STALLS);
eval 'sub F10H_DISPATCH_STALLS_BRANCH_ABORT_RETIRE () {0xd2;}' unless defined(&F10H_DISPATCH_STALLS_BRANCH_ABORT_RETIRE);
eval 'sub F10H_DISPATCH_STALLS_SERIALIZATION () {0xd3;}' unless defined(&F10H_DISPATCH_STALLS_SERIALIZATION);
eval 'sub F10H_DISPATCH_STALLS_SEGMENT_LOAD () {0xd4;}' unless defined(&F10H_DISPATCH_STALLS_SEGMENT_LOAD);
eval 'sub F10H_DISPATCH_STALLS_REORDER_BUF_FULL () {0xd5;}' unless defined(&F10H_DISPATCH_STALLS_REORDER_BUF_FULL);
eval 'sub F10H_DISPATCH_STALLS_RSV_STATION_FULL () {0xd6;}' unless defined(&F10H_DISPATCH_STALLS_RSV_STATION_FULL);
eval 'sub F10H_DISPATCH_STALLS_FPU_FULL () {0xd7;}' unless defined(&F10H_DISPATCH_STALLS_FPU_FULL);
eval 'sub F10H_DISPATCH_STALLS_LS_FULL () {0xd8;}' unless defined(&F10H_DISPATCH_STALLS_LS_FULL);
eval 'sub F10H_DISPATCH_STALLS_WAITING_ALL_QUITE () {0xd9;}' unless defined(&F10H_DISPATCH_STALLS_WAITING_ALL_QUITE);
eval 'sub F10H_DISPATCH_STALLS_FAR_TRANSFER () {0xda;}' unless defined(&F10H_DISPATCH_STALLS_FAR_TRANSFER);
eval 'sub F10H_FPU_EXCEPTIONS () {0xdb;}' unless defined(&F10H_FPU_EXCEPTIONS);
eval 'sub F10H_DR0_BREAKPOINT_MATCHES () {0xdc;}' unless defined(&F10H_DR0_BREAKPOINT_MATCHES);
eval 'sub F10H_DR1_BREAKPOINT_MATCHES () {0xdd;}' unless defined(&F10H_DR1_BREAKPOINT_MATCHES);
eval 'sub F10H_DR2_BREAKPOINT_MATCHES () {0xde;}' unless defined(&F10H_DR2_BREAKPOINT_MATCHES);
eval 'sub F10H_DR3_BREAKPOINT_MATCHES () {0xdf;}' unless defined(&F10H_DR3_BREAKPOINT_MATCHES);
eval 'sub F10H_DRAM_ACCESSES () {0xe0;}' unless defined(&F10H_DRAM_ACCESSES);
eval 'sub F10H_DRAM_CONTROLLER_PT_OVERFLOWS () {0xe1;}' unless defined(&F10H_DRAM_CONTROLLER_PT_OVERFLOWS);
eval 'sub F10H_MEM_CONTROLLER_DRAM_COMMAND_SLOTS_MISSED () {0xe2;}' unless defined(&F10H_MEM_CONTROLLER_DRAM_COMMAND_SLOTS_MISSED);
eval 'sub F10H_MEM_CONTROLLER_TURNAROUNDS () {0xe3;}' unless defined(&F10H_MEM_CONTROLLER_TURNAROUNDS);
eval 'sub F10H_MEM_CONTROLLER_BYPASS_COUNTER_SATURATION () {0xe4;}' unless defined(&F10H_MEM_CONTROLLER_BYPASS_COUNTER_SATURATION);
eval 'sub F10H_THERMAL_STATUS () {0xe8;}' unless defined(&F10H_THERMAL_STATUS);
eval 'sub F10H_CPU_IO_REQUESTS_TO_MEMORY_IO () {0xe9;}' unless defined(&F10H_CPU_IO_REQUESTS_TO_MEMORY_IO);
eval 'sub F10H_CACHE_BLOCK_COMMANDS () {0xea;}' unless defined(&F10H_CACHE_BLOCK_COMMANDS);
eval 'sub F10H_SIZED_COMMANDS () {0xeb;}' unless defined(&F10H_SIZED_COMMANDS);
eval 'sub F10H_PROBE_RESPONSES_AND_UPSTREAM_REQUESTS () {0xec;}' unless defined(&F10H_PROBE_RESPONSES_AND_UPSTREAM_REQUESTS);
eval 'sub F10H_GART_EVENTS () {0xee;}' unless defined(&F10H_GART_EVENTS);
eval 'sub F10H_MEMORY_CONTROLLER_REQUESTS () {0x1f0;}' unless defined(&F10H_MEMORY_CONTROLLER_REQUESTS);
eval 'sub F10H_CPU_TO_DRAM_REQUESTS_TO_TARGET_NODE () {0x1e0;}' unless defined(&F10H_CPU_TO_DRAM_REQUESTS_TO_TARGET_NODE);
eval 'sub F10H_IO_TO_DRAM_REQUESTS_TO_TARGET_NODE () {0x1e1;}' unless defined(&F10H_IO_TO_DRAM_REQUESTS_TO_TARGET_NODE);
eval 'sub F10H_CPU_READ_CMD_LATENCY_TARGET_NODE_03 () {0x1e2;}' unless defined(&F10H_CPU_READ_CMD_LATENCY_TARGET_NODE_03);
eval 'sub F10H_CPU_READ_CMD_REQUESTS_TARGET_NODE_03 () {0x1e3;}' unless defined(&F10H_CPU_READ_CMD_REQUESTS_TARGET_NODE_03);
eval 'sub F10H_CPU_READ_CMD_LATENCY_TARGET_NODE_47 () {0x1e4;}' unless defined(&F10H_CPU_READ_CMD_LATENCY_TARGET_NODE_47);
eval 'sub F10H_CPU_READ_CMD_REQUESTS_TARGET_NODE_47 () {0x1e5;}' unless defined(&F10H_CPU_READ_CMD_REQUESTS_TARGET_NODE_47);
eval 'sub F10H_CPU_CMD_LATENCY_TO_TARGET_NODE_0347 () {0x1e6;}' unless defined(&F10H_CPU_CMD_LATENCY_TO_TARGET_NODE_0347);
eval 'sub F10H_CPU_REQUESTS_TO_TARGET_NODE_0347 () {0x1e7;}' unless defined(&F10H_CPU_REQUESTS_TO_TARGET_NODE_0347);
eval 'sub F10H_HYPERTRANSPORT_LINK0_TRANSMIT_BANDWIDTH () {0xf6;}' unless defined(&F10H_HYPERTRANSPORT_LINK0_TRANSMIT_BANDWIDTH);
eval 'sub F10H_HYPERTRANSPORT_LINK1_TRANSMIT_BANDWIDTH () {0xf7;}' unless defined(&F10H_HYPERTRANSPORT_LINK1_TRANSMIT_BANDWIDTH);
eval 'sub F10H_HYPERTRANSPORT_LINK2_TRANSMIT_BANDWIDTH () {0xf8;}' unless defined(&F10H_HYPERTRANSPORT_LINK2_TRANSMIT_BANDWIDTH);
eval 'sub F10H_HYPERTRANSPORT_LINK3_TRANSMIT_BANDWIDTH () {0x1f9;}' unless defined(&F10H_HYPERTRANSPORT_LINK3_TRANSMIT_BANDWIDTH);
eval 'sub F10H_L3_EVICTIONS () {0x4e3;}' unless defined(&F10H_L3_EVICTIONS);
1;
