require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_I386_PTE_H_)) {
    eval 'sub _I386_PTE_H_ () {1;}' unless defined(&_I386_PTE_H_);
    if(defined(&_KERNEL_OPT)) {
	require './i386/opt_xen.ph';
    }
    if(!defined(&_LOCORE)) {
	if(defined(&PAE)) {
	} else {
	}
    }
    if(defined(&PAE)) {
	eval 'sub L1_SHIFT () {12;}' unless defined(&L1_SHIFT);
	eval 'sub L2_SHIFT () {21;}' unless defined(&L2_SHIFT);
	eval 'sub L3_SHIFT () {30;}' unless defined(&L3_SHIFT);
	eval 'sub NBPD_L1 () {(1 <<  &L1_SHIFT);}' unless defined(&NBPD_L1);
	eval 'sub NBPD_L2 () {(1 <<  &L2_SHIFT);}' unless defined(&NBPD_L2);
	eval 'sub NBPD_L3 () {(1 <<  &L3_SHIFT);}' unless defined(&NBPD_L3);
	eval 'sub L3_MASK () {0xc0000000;}' unless defined(&L3_MASK);
	eval 'sub L2_REALMASK () {0x3fe00000;}' unless defined(&L2_REALMASK);
	eval 'sub L2_MASK () {( &L2_REALMASK |  &L3_MASK);}' unless defined(&L2_MASK);
	eval 'sub L1_MASK () {0x1ff000;}' unless defined(&L1_MASK);
	eval 'sub L3_FRAME () {( &L3_MASK);}' unless defined(&L3_FRAME);
	eval 'sub L2_FRAME () {( &L3_FRAME |  &L2_MASK);}' unless defined(&L2_FRAME);
	eval 'sub L1_FRAME () {( &L2_FRAME| &L1_MASK);}' unless defined(&L1_FRAME);
	eval 'sub PG_FRAME () {0xffffffffff000;}' unless defined(&PG_FRAME);
	eval 'sub PG_LGFRAME () {0xfffffffe00000;}' unless defined(&PG_LGFRAME);
	eval 'sub l2tol3 {
	    my($idx) = @_;
    	    eval q((($idx) >> ( &L3_SHIFT -  &L2_SHIFT)));
	}' unless defined(&l2tol3);
	eval 'sub l2tol2 {
	    my($idx) = @_;
    	    eval q((($idx) & ( &L2_REALMASK >>  &L2_SHIFT)));
	}' unless defined(&l2tol2);
    } else {
	eval 'sub L1_SHIFT () {12;}' unless defined(&L1_SHIFT);
	eval 'sub L2_SHIFT () {22;}' unless defined(&L2_SHIFT);
	eval 'sub NBPD_L1 () {(1 <<  &L1_SHIFT);}' unless defined(&NBPD_L1);
	eval 'sub NBPD_L2 () {(1 <<  &L2_SHIFT);}' unless defined(&NBPD_L2);
	eval 'sub L2_MASK () {0xffc00000;}' unless defined(&L2_MASK);
	eval 'sub L1_MASK () {0x3ff000;}' unless defined(&L1_MASK);
	eval 'sub L2_FRAME () {( &L2_MASK);}' unless defined(&L2_FRAME);
	eval 'sub L1_FRAME () {( &L2_FRAME| &L1_MASK);}' unless defined(&L1_FRAME);
	eval 'sub PG_FRAME () {0xfffff000;}' unless defined(&PG_FRAME);
	eval 'sub PG_LGFRAME () {0xffc00000;}' unless defined(&PG_LGFRAME);
    }
    eval 'sub PG_V () {0x1;}' unless defined(&PG_V);
    eval 'sub PG_RO () {0x;}' unless defined(&PG_RO);
    eval 'sub PG_RW () {0x2;}' unless defined(&PG_RW);
    eval 'sub PG_u () {0x4;}' unless defined(&PG_u);
    eval 'sub PG_PROT () {0x806;}' unless defined(&PG_PROT);
    eval 'sub PG_WT () {0x8;}' unless defined(&PG_WT);
    eval 'sub PG_N () {0x10;}' unless defined(&PG_N);
    eval 'sub PG_U () {0x20;}' unless defined(&PG_U);
    eval 'sub PG_M () {0x40;}' unless defined(&PG_M);
    eval 'sub PG_PAT () {0x80;}' unless defined(&PG_PAT);
    eval 'sub PG_PS () {0x80;}' unless defined(&PG_PS);
    eval 'sub PG_G () {0x100;}' unless defined(&PG_G);
    eval 'sub PG_AVAIL1 () {0x200;}' unless defined(&PG_AVAIL1);
    eval 'sub PG_AVAIL2 () {0x400;}' unless defined(&PG_AVAIL2);
    eval 'sub PG_AVAIL3 () {0x800;}' unless defined(&PG_AVAIL3);
    eval 'sub PG_LGPAT () {0x1000;}' unless defined(&PG_LGPAT);
    eval 'sub PG_KR () {0x;}' unless defined(&PG_KR);
    eval 'sub PG_KW () {0x2;}' unless defined(&PG_KW);
    if(defined(&PAE)) {
	eval 'sub PG_NX () {0x8000000000000000;}' unless defined(&PG_NX);
    } else {
	eval 'sub PG_NX () {0;}' unless defined(&PG_NX);
    }
    require 'x86/pte.ph';
}
1;
