require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_I386_PTRACE_H_)) {
    eval 'sub _I386_PTRACE_H_ () {1;}' unless defined(&_I386_PTRACE_H_);
    eval 'sub PT_STEP () {( &PT_FIRSTMACH + 0);}' unless defined(&PT_STEP);
    eval 'sub PT_GETREGS () {( &PT_FIRSTMACH + 1);}' unless defined(&PT_GETREGS);
    eval 'sub PT_SETREGS () {( &PT_FIRSTMACH + 2);}' unless defined(&PT_SETREGS);
    eval 'sub PT_GETFPREGS () {( &PT_FIRSTMACH + 3);}' unless defined(&PT_GETFPREGS);
    eval 'sub PT_SETFPREGS () {( &PT_FIRSTMACH + 4);}' unless defined(&PT_SETFPREGS);
    eval 'sub __HAVE_PTRACE_MACHDEP () {1;}' unless defined(&__HAVE_PTRACE_MACHDEP);
    eval 'sub __HAVE_PROCFS_MACHDEP () {1;}' unless defined(&__HAVE_PROCFS_MACHDEP);
    eval 'sub PT_GETXMMREGS () {( &PT_FIRSTMACH + 5);}' unless defined(&PT_GETXMMREGS);
    eval 'sub PT_SETXMMREGS () {( &PT_FIRSTMACH + 6);}' unless defined(&PT_SETXMMREGS);
    eval 'sub PT_GETDBREGS () {( &PT_FIRSTMACH + 7);}' unless defined(&PT_GETDBREGS);
    eval 'sub PT_SETDBREGS () {( &PT_FIRSTMACH + 8);}' unless defined(&PT_SETDBREGS);
    eval 'sub PT_SETSTEP () {( &PT_FIRSTMACH + 9);}' unless defined(&PT_SETSTEP);
    eval 'sub PT_CLEARSTEP () {( &PT_FIRSTMACH + 10);}' unless defined(&PT_CLEARSTEP);
    eval 'sub PT_MACHDEP_STRINGS () {"PT_STEP", "PT_GETREGS", "PT_SETREGS", "PT_GETFPREGS", "PT_SETFPREGS", "PT_GETXMMREGS", "PT_SETXMMREGS", "PT_GETDBREGS", "PT_SETDBREGS", "PT_SETSTEP", "PT_CLEARSTEP",;}' unless defined(&PT_MACHDEP_STRINGS);
    require 'machine/reg.ph';
    eval 'sub PTRACE_REG_PC {
        my($r) = @_;
	    eval q(($r)-> &r_eip);
    }' unless defined(&PTRACE_REG_PC);
    eval 'sub PTRACE_REG_SET_PC {
        my($r, $v) = @_;
	    eval q(($r)-> &r_eip = ($v));
    }' unless defined(&PTRACE_REG_SET_PC);
    eval 'sub PTRACE_REG_SP {
        my($r) = @_;
	    eval q(($r)-> &r_esp);
    }' unless defined(&PTRACE_REG_SP);
    eval 'sub PTRACE_REG_INTRV {
        my($r) = @_;
	    eval q(($r)-> &r_eax);
    }' unless defined(&PTRACE_REG_INTRV);
    eval 'sub PTRACE_BREAKPOINT () {(( &const  $uint8_t[]) { 0xcc });}' unless defined(&PTRACE_BREAKPOINT);
    eval 'sub PTRACE_BREAKPOINT_SIZE () {1;}' unless defined(&PTRACE_BREAKPOINT_SIZE);
    eval 'sub PTRACE_BREAKPOINT_ADJ () {$sizeof{ &PTRACE_BREAKPOINT};}' unless defined(&PTRACE_BREAKPOINT_ADJ);
    if(defined(&_KERNEL)) {
	eval 'sub PTRACE_MACHDEP_REQUEST_CASES () { &case  &PT_GETXMMREGS:  &case  &PT_SETXMMREGS:;}' unless defined(&PTRACE_MACHDEP_REQUEST_CASES);
	eval 'sub PROCFS_MACHDEP_NODE_TYPES () { &Pmachdep_xmmregs,;}' unless defined(&PROCFS_MACHDEP_NODE_TYPES);
	eval 'sub PROCFS_MACHDEP_NODETYPE_CASES () { &case  &Pmachdep_xmmregs:;}' unless defined(&PROCFS_MACHDEP_NODETYPE_CASES);
	eval 'sub PROCFS_MACHDEP_PROTECT_CASES () { &case  &Pmachdep_xmmregs:;}' unless defined(&PROCFS_MACHDEP_PROTECT_CASES);
	eval 'sub PROCFS_MACHDEP_NODETYPE_DEFNS () {{  &DT_REG,  &N("xmmregs"),  &Pmachdep_xmmregs,  &procfs_machdep_validxmmregs },;}' unless defined(&PROCFS_MACHDEP_NODETYPE_DEFNS);
    }
}
1;
