require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/ptrace.ph';
if(defined(&_KERNEL)) {
    eval("sub PFSroot () { 0; }") unless defined(&PFSroot);
    eval("sub PFScurproc () { 1; }") unless defined(&PFScurproc);
    eval("sub PFSself () { 2; }") unless defined(&PFSself);
    eval("sub PFSproc () { 3; }") unless defined(&PFSproc);
    eval("sub PFSfile () { 4; }") unless defined(&PFSfile);
    eval("sub PFSexe () { 5; }") unless defined(&PFSexe);
    eval("sub PFSmem () { 6; }") unless defined(&PFSmem);
    eval("sub PFSregs () { 7; }") unless defined(&PFSregs);
    eval("sub PFSfpregs () { 8; }") unless defined(&PFSfpregs);
    eval("sub PFSstat () { 9; }") unless defined(&PFSstat);
    eval("sub PFSstatus () { 10; }") unless defined(&PFSstatus);
    eval("sub PFSnote () { 11; }") unless defined(&PFSnote);
    eval("sub PFSnotepg () { 12; }") unless defined(&PFSnotepg);
    eval("sub PFSmap () { 13; }") unless defined(&PFSmap);
    eval("sub PFScmdline () { 14; }") unless defined(&PFScmdline);
    eval("sub PFSmeminfo () { 15; }") unless defined(&PFSmeminfo);
    eval("sub PFScpuinfo () { 16; }") unless defined(&PFScpuinfo);
    eval("sub PFSmaps () { 17; }") unless defined(&PFSmaps);
    eval("sub PFSfd () { 18; }") unless defined(&PFSfd);
    eval("sub PFSuptime () { 19; }") unless defined(&PFSuptime);
    eval("sub PFSmounts () { 20; }") unless defined(&PFSmounts);
    eval("sub PFScwd () { 21; }") unless defined(&PFScwd);
    eval("sub PFSchroot () { 22; }") unless defined(&PFSchroot);
    eval("sub PFSemul () { 23; }") unless defined(&PFSemul);
    eval("sub PFSdevices () { 24; }") unless defined(&PFSdevices);
    eval("sub PFScpustat () { 25; }") unless defined(&PFScpustat);
    eval("sub PFSloadavg () { 26; }") unless defined(&PFSloadavg);
    eval("sub PFSstatm () { 27; }") unless defined(&PFSstatm);
    eval("sub PFSversion () { 28; }") unless defined(&PFSversion);
    eval("sub PFStask () { 29; }") unless defined(&PFStask);
    eval("sub PFSauxv () { 30; }") unless defined(&PFSauxv);
    eval 'sub pfs_type () { ($pfs_key->{pk_type});}' unless defined(&pfs_type);
    eval 'sub pfs_pid () { ($pfs_key->{pk_pid});}' unless defined(&pfs_pid);
    eval 'sub pfs_fd () { ($pfs_key->{pk_fd});}' unless defined(&pfs_fd);
    eval 'sub PROCFS_NOTELEN () {64;}' unless defined(&PROCFS_NOTELEN);
    eval 'sub PROCFS_MAXNAMLEN () {255;}' unless defined(&PROCFS_MAXNAMLEN);
}
eval 'sub PROCFS_ARGSVERSION () {1;}' unless defined(&PROCFS_ARGSVERSION);
eval 'sub PROCFSMNT_LINUXCOMPAT () {0x1;}' unless defined(&PROCFSMNT_LINUXCOMPAT);
eval 'sub PROCFSMNT_BITS () {"\\177\\20" "b\\00linuxcompat\\0";}' unless defined(&PROCFSMNT_BITS);
if(defined(&_KERNEL)) {
    eval 'sub CNEQ {
        my($cnp, $s, $len) = @_;
	    eval q((($cnp)-> &cn_namelen == ($len)  && ( &memcmp(($s), ($cnp)-> &cn_nameptr, ($len)) == 0)));
    }' unless defined(&CNEQ);
    eval 'sub UIO_MX () {32;}' unless defined(&UIO_MX);
    eval 'sub PROCFS_FILENO {
        my($pid, $type, $fd) = @_;
	    eval q((( <  &PFSproc) ? ( + 2) : (( == -1) ? (((+1) << 5) + ) : (((+1) << 16) | ( << 5) | ( ($type))))));
    }' unless defined(&PROCFS_FILENO);
    eval 'sub PROCFS_TYPE {
        my($type) = @_;
	    eval q((($type) & 0x1f));
    }' unless defined(&PROCFS_TYPE);
    eval 'sub VFSTOPROC {
        my($mp) = @_;
	    eval q((($mp)-> &mnt_data));
    }' unless defined(&VFSTOPROC);
    eval 'sub VTOPFS {
        my($vp) = @_;
	    eval q((($vp)-> &v_data));
    }' unless defined(&VTOPFS);
    eval 'sub PFSTOV {
        my($pfs) = @_;
	    eval q((($pfs)-> &pfs_vnode));
    }' unless defined(&PFSTOV);
    eval 'sub PROCFS_LOCKED () {0x1;}' unless defined(&PROCFS_LOCKED);
    eval 'sub PROCFS_WANT () {0x2;}' unless defined(&PROCFS_WANT);
    if(defined(&__HAVE_PROCFS_MACHDEP)) {
    }
}
1;
