require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_IF_MEDIA_H_)) {
    eval 'sub _NET_IF_MEDIA_H_ () {1;}' unless defined(&_NET_IF_MEDIA_H_);
    if(defined(&_KERNEL)) {
	require 'sys/queue.ph';
    }
    eval 'sub IFM_NMASK () {0xe0;}' unless defined(&IFM_NMASK);
    eval 'sub IFM_TMASK () {0x1f;}' unless defined(&IFM_TMASK);
    eval 'sub IFM_IMASK () {0xf0000000;}' unless defined(&IFM_IMASK);
    eval 'sub IFM_ISHIFT () {28;}' unless defined(&IFM_ISHIFT);
    eval 'sub IFM_OMASK () {0xff00;}' unless defined(&IFM_OMASK);
    eval 'sub IFM_MMASK () {0x70000;}' unless defined(&IFM_MMASK);
    eval 'sub IFM_MSHIFT () {16;}' unless defined(&IFM_MSHIFT);
    eval 'sub IFM_GMASK () {0xff00000;}' unless defined(&IFM_GMASK);
    eval 'sub IFM_TYPE {
        my($x) = @_;
	    eval q((($x) &  &IFM_NMASK));
    }' unless defined(&IFM_TYPE);
    eval 'sub IFM_SUBTYPE {
        my($x) = @_;
	    eval q((($x) &  &IFM_TMASK));
    }' unless defined(&IFM_SUBTYPE);
    eval 'sub IFM_INST {
        my($x) = @_;
	    eval q(((($x) &  &IFM_IMASK) >>  &IFM_ISHIFT));
    }' unless defined(&IFM_INST);
    eval 'sub IFM_OPTIONS {
        my($x) = @_;
	    eval q((($x) & ( &IFM_OMASK |  &IFM_GMASK)));
    }' unless defined(&IFM_OPTIONS);
    eval 'sub IFM_MODE {
        my($x) = @_;
	    eval q((($x) &  &IFM_MMASK));
    }' unless defined(&IFM_MODE);
    eval 'sub IFM_TYPE_MATCH {
        my($dt, $t) = @_;
	    eval q(( &IFM_TYPE(($dt)) == 0||  &IFM_TYPE(($dt)) ==  &IFM_TYPE(($t))));
    }' unless defined(&IFM_TYPE_MATCH);
    eval 'sub IFM_INST_MAX () { &IFM_INST( &IFM_IMASK);}' unless defined(&IFM_INST_MAX);
    eval 'sub IFM_INST_ANY () {( -1);}' unless defined(&IFM_INST_ANY);
    eval 'sub IFM_STATUS_VALID () { &IFM_AVALID;}' unless defined(&IFM_STATUS_VALID);
    eval 'sub IFM_STATUS_VALID_LIST () {{  &IFM_AVALID, 0, };}' unless defined(&IFM_STATUS_VALID_LIST);
    eval 'sub IFM_MAKEWORD {
        my($type, $subtype, $options, $instance) = @_;
	    eval q((($type) | ($subtype) | ($options) | (($instance) <<  &IFM_ISHIFT)));
    }' unless defined(&IFM_MAKEWORD);
    eval 'sub IFM_MAKEMODE {
        my($mode) = @_;
	    eval q(((($mode) <<  &IFM_MSHIFT) &  &IFM_MMASK));
    }' unless defined(&IFM_MAKEMODE);
    eval 'sub IFM_GENERIC () {0x;}' unless defined(&IFM_GENERIC);
    eval 'sub IFM_ETHER () {0x20;}' unless defined(&IFM_ETHER);
    eval 'sub IFM_TOKEN () {0x40;}' unless defined(&IFM_TOKEN);
    eval 'sub IFM_FDDI () {0x60;}' unless defined(&IFM_FDDI);
    eval 'sub IFM_IEEE80211 () {0x80;}' unless defined(&IFM_IEEE80211);
    eval 'sub IFM_CARP () {0xc0;}' unless defined(&IFM_CARP);
    eval 'sub IFM_NMIN () { &IFM_ETHER;}' unless defined(&IFM_NMIN);
    eval 'sub IFM_NMAX () { &IFM_NMASK;}' unless defined(&IFM_NMAX);
    eval 'sub IFM_AUTO () {0;}' unless defined(&IFM_AUTO);
    eval 'sub IFM_MANUAL () {1;}' unless defined(&IFM_MANUAL);
    eval 'sub IFM_NONE () {2;}' unless defined(&IFM_NONE);
    eval 'sub IFM_AVALID () {0x1;}' unless defined(&IFM_AVALID);
    eval 'sub IFM_ACTIVE () {0x2;}' unless defined(&IFM_ACTIVE);
    eval 'sub IFM_FDX () {0x100000;}' unless defined(&IFM_FDX);
    eval 'sub IFM_HDX () {0x200000;}' unless defined(&IFM_HDX);
    eval 'sub IFM_FLOW () {0x400000;}' unless defined(&IFM_FLOW);
    eval 'sub IFM_FLAG0 () {0x1000000;}' unless defined(&IFM_FLAG0);
    eval 'sub IFM_FLAG1 () {0x2000000;}' unless defined(&IFM_FLAG1);
    eval 'sub IFM_FLAG2 () {0x4000000;}' unless defined(&IFM_FLAG2);
    eval 'sub IFM_LOOP () {0x8000000;}' unless defined(&IFM_LOOP);
    eval 'sub IFM_10_T () {3;}' unless defined(&IFM_10_T);
    eval 'sub IFM_10_2 () {4;}' unless defined(&IFM_10_2);
    eval 'sub IFM_10_5 () {5;}' unless defined(&IFM_10_5);
    eval 'sub IFM_100_TX () {6;}' unless defined(&IFM_100_TX);
    eval 'sub IFM_100_FX () {7;}' unless defined(&IFM_100_FX);
    eval 'sub IFM_100_T4 () {8;}' unless defined(&IFM_100_T4);
    eval 'sub IFM_100_VG () {9;}' unless defined(&IFM_100_VG);
    eval 'sub IFM_100_T2 () {10;}' unless defined(&IFM_100_T2);
    eval 'sub IFM_1000_SX () {11;}' unless defined(&IFM_1000_SX);
    eval 'sub IFM_10_STP () {12;}' unless defined(&IFM_10_STP);
    eval 'sub IFM_10_FL () {13;}' unless defined(&IFM_10_FL);
    eval 'sub IFM_1000_LX () {14;}' unless defined(&IFM_1000_LX);
    eval 'sub IFM_1000_CX () {15;}' unless defined(&IFM_1000_CX);
    eval 'sub IFM_1000_T () {16;}' unless defined(&IFM_1000_T);
    eval 'sub IFM_HPNA_1 () {17;}' unless defined(&IFM_HPNA_1);
    eval 'sub IFM_10G_LR () {18;}' unless defined(&IFM_10G_LR);
    eval 'sub IFM_10G_SR () {19;}' unless defined(&IFM_10G_SR);
    eval 'sub IFM_10G_CX4 () {20;}' unless defined(&IFM_10G_CX4);
    eval 'sub IFM_2500_SX () {21;}' unless defined(&IFM_2500_SX);
    eval 'sub IFM_1000_BX10 () {22;}' unless defined(&IFM_1000_BX10);
    eval 'sub IFM_10G_TWINAX () {23;}' unless defined(&IFM_10G_TWINAX);
    eval 'sub IFM_10G_TWINAX_LONG () {24;}' unless defined(&IFM_10G_TWINAX_LONG);
    eval 'sub IFM_10G_LRM () {25;}' unless defined(&IFM_10G_LRM);
    eval 'sub IFM_10G_T () {26;}' unless defined(&IFM_10G_T);
    eval 'sub IFM_1000_KX () {27;}' unless defined(&IFM_1000_KX);
    eval 'sub IFM_2500_KX () {28;}' unless defined(&IFM_2500_KX);
    eval 'sub IFM_2500_T () {29;}' unless defined(&IFM_2500_T);
    eval 'sub IFM_5000_T () {30;}' unless defined(&IFM_5000_T);
    eval 'sub IFM_ETH_MASTER () {0x100;}' unless defined(&IFM_ETH_MASTER);
    eval 'sub IFM_ETH_RXPAUSE () {0x200;}' unless defined(&IFM_ETH_RXPAUSE);
    eval 'sub IFM_ETH_TXPAUSE () {0x400;}' unless defined(&IFM_ETH_TXPAUSE);
    eval 'sub IFM_ETH_FMASK () {( &IFM_FLOW |  &IFM_ETH_RXPAUSE |  &IFM_ETH_TXPAUSE);}' unless defined(&IFM_ETH_FMASK);
    eval 'sub IFM_TOK_STP4 () {3;}' unless defined(&IFM_TOK_STP4);
    eval 'sub IFM_TOK_STP16 () {4;}' unless defined(&IFM_TOK_STP16);
    eval 'sub IFM_TOK_UTP4 () {5;}' unless defined(&IFM_TOK_UTP4);
    eval 'sub IFM_TOK_UTP16 () {6;}' unless defined(&IFM_TOK_UTP16);
    eval 'sub IFM_TOK_ETR () {0x200;}' unless defined(&IFM_TOK_ETR);
    eval 'sub IFM_TOK_SRCRT () {0x400;}' unless defined(&IFM_TOK_SRCRT);
    eval 'sub IFM_TOK_ALLR () {0x800;}' unless defined(&IFM_TOK_ALLR);
    eval 'sub IFM_FDDI_SMF () {3;}' unless defined(&IFM_FDDI_SMF);
    eval 'sub IFM_FDDI_MMF () {4;}' unless defined(&IFM_FDDI_MMF);
    eval 'sub IFM_FDDI_UTP () {5;}' unless defined(&IFM_FDDI_UTP);
    eval 'sub IFM_FDDI_DA () {0x100;}' unless defined(&IFM_FDDI_DA);
    eval 'sub IFM_IEEE80211_FH1 () {3;}' unless defined(&IFM_IEEE80211_FH1);
    eval 'sub IFM_IEEE80211_FH2 () {4;}' unless defined(&IFM_IEEE80211_FH2);
    eval 'sub IFM_IEEE80211_DS2 () {5;}' unless defined(&IFM_IEEE80211_DS2);
    eval 'sub IFM_IEEE80211_DS5 () {6;}' unless defined(&IFM_IEEE80211_DS5);
    eval 'sub IFM_IEEE80211_DS11 () {7;}' unless defined(&IFM_IEEE80211_DS11);
    eval 'sub IFM_IEEE80211_DS1 () {8;}' unless defined(&IFM_IEEE80211_DS1);
    eval 'sub IFM_IEEE80211_DS22 () {9;}' unless defined(&IFM_IEEE80211_DS22);
    eval 'sub IFM_IEEE80211_OFDM6 () {10;}' unless defined(&IFM_IEEE80211_OFDM6);
    eval 'sub IFM_IEEE80211_OFDM9 () {11;}' unless defined(&IFM_IEEE80211_OFDM9);
    eval 'sub IFM_IEEE80211_OFDM12 () {12;}' unless defined(&IFM_IEEE80211_OFDM12);
    eval 'sub IFM_IEEE80211_OFDM18 () {13;}' unless defined(&IFM_IEEE80211_OFDM18);
    eval 'sub IFM_IEEE80211_OFDM24 () {14;}' unless defined(&IFM_IEEE80211_OFDM24);
    eval 'sub IFM_IEEE80211_OFDM36 () {15;}' unless defined(&IFM_IEEE80211_OFDM36);
    eval 'sub IFM_IEEE80211_OFDM48 () {16;}' unless defined(&IFM_IEEE80211_OFDM48);
    eval 'sub IFM_IEEE80211_OFDM54 () {17;}' unless defined(&IFM_IEEE80211_OFDM54);
    eval 'sub IFM_IEEE80211_OFDM72 () {18;}' unless defined(&IFM_IEEE80211_OFDM72);
    eval 'sub IFM_IEEE80211_DS354k () {19;}' unless defined(&IFM_IEEE80211_DS354k);
    eval 'sub IFM_IEEE80211_DS512k () {20;}' unless defined(&IFM_IEEE80211_DS512k);
    eval 'sub IFM_IEEE80211_OFDM3 () {21;}' unless defined(&IFM_IEEE80211_OFDM3);
    eval 'sub IFM_IEEE80211_OFDM4 () {22;}' unless defined(&IFM_IEEE80211_OFDM4);
    eval 'sub IFM_IEEE80211_OFDM27 () {23;}' unless defined(&IFM_IEEE80211_OFDM27);
    eval 'sub IFM_IEEE80211_MCS () {24;}' unless defined(&IFM_IEEE80211_MCS);
    eval 'sub IFM_IEEE80211_ADHOC () {0x100;}' unless defined(&IFM_IEEE80211_ADHOC);
    eval 'sub IFM_IEEE80211_HOSTAP () {0x200;}' unless defined(&IFM_IEEE80211_HOSTAP);
    eval 'sub IFM_IEEE80211_MONITOR () {0x400;}' unless defined(&IFM_IEEE80211_MONITOR);
    eval 'sub IFM_IEEE80211_TURBO () {0x800;}' unless defined(&IFM_IEEE80211_TURBO);
    eval 'sub IFM_IEEE80211_IBSS () {0x1000;}' unless defined(&IFM_IEEE80211_IBSS);
    eval 'sub IFM_IEEE80211_WDS () {0x2000;}' unless defined(&IFM_IEEE80211_WDS);
    eval 'sub IFM_IEEE80211_MBSS () {0x4000;}' unless defined(&IFM_IEEE80211_MBSS);
    eval 'sub IFM_IEEE80211_11A () {0x10000;}' unless defined(&IFM_IEEE80211_11A);
    eval 'sub IFM_IEEE80211_11B () {0x20000;}' unless defined(&IFM_IEEE80211_11B);
    eval 'sub IFM_IEEE80211_11G () {0x30000;}' unless defined(&IFM_IEEE80211_11G);
    eval 'sub IFM_IEEE80211_FH () {0x40000;}' unless defined(&IFM_IEEE80211_FH);
    eval 'sub IFM_IEEE80211_11NA () {0x50000;}' unless defined(&IFM_IEEE80211_11NA);
    eval 'sub IFM_IEEE80211_11NG () {0x60000;}' unless defined(&IFM_IEEE80211_11NG);
    eval 'sub IFM_TYPE_DESCRIPTIONS () {{ {  &IFM_ETHER, "Ethernet" }, {  &IFM_ETHER, "ether" }, {  &IFM_TOKEN, "TokenRing" }, {  &IFM_TOKEN, "token" }, {  &IFM_FDDI, "FDDI" }, {  &IFM_IEEE80211, "IEEE802.11" }, {  &IFM_CARP, "CARP" }, { 0,  &NULL }, };}' unless defined(&IFM_TYPE_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_DESCRIPTIONS () {{ {  &IFM_AUTO, "autoselect" }, {  &IFM_AUTO, "auto" }, {  &IFM_MANUAL, "manual" }, {  &IFM_NONE, "none" }, {  &IFM_ETHER |  &IFM_10_T, "10baseT" }, {  &IFM_ETHER |  &IFM_10_T, "10baseT/UTP" }, {  &IFM_ETHER |  &IFM_10_T, "UTP" }, {  &IFM_ETHER |  &IFM_10_T, "10UTP" }, {  &IFM_ETHER |  &IFM_10_T, "10BASE-T" }, {  &IFM_ETHER |  &IFM_10_2, "10base2" }, {  &IFM_ETHER |  &IFM_10_2, "10base2/BNC" }, {  &IFM_ETHER |  &IFM_10_2, "BNC" }, {  &IFM_ETHER |  &IFM_10_2, "10BNC" }, {  &IFM_ETHER |  &IFM_10_2, "10BASE2" }, {  &IFM_ETHER |  &IFM_10_5, "10base5" }, {  &IFM_ETHER |  &IFM_10_5, "10base5/AUI" }, {  &IFM_ETHER |  &IFM_10_5, "AUI" }, {  &IFM_ETHER |  &IFM_10_5, "10AUI" }, {  &IFM_ETHER |  &IFM_10_5, "10BASE5" }, {  &IFM_ETHER |  &IFM_100_TX, "100baseTX" }, {  &IFM_ETHER |  &IFM_100_TX, "100TX" }, {  &IFM_ETHER |  &IFM_100_TX, "100BASE-TX" }, {  &IFM_ETHER |  &IFM_100_FX, "100baseFX" }, {  &IFM_ETHER |  &IFM_100_FX, "100FX" }, {  &IFM_ETHER |  &IFM_100_FX, "100BASE-FX" }, {  &IFM_ETHER |  &IFM_100_T4, "100baseT4" }, {  &IFM_ETHER |  &IFM_100_T4, "100T4" }, {  &IFM_ETHER |  &IFM_100_T4, "100BASE-T4" }, {  &IFM_ETHER |  &IFM_100_VG, "100baseVG" }, {  &IFM_ETHER |  &IFM_100_VG, "100VG" }, {  &IFM_ETHER |  &IFM_100_VG, "100VG-AnyLAN" }, {  &IFM_ETHER |  &IFM_100_T2, "100baseT2" }, {  &IFM_ETHER |  &IFM_100_T2, "100T2" }, {  &IFM_ETHER |  &IFM_100_T2, "100BASE-T2" }, {  &IFM_ETHER |  &IFM_1000_SX, "1000baseSX" }, {  &IFM_ETHER |  &IFM_1000_SX, "1000SX" }, {  &IFM_ETHER |  &IFM_1000_SX, "1000BASE-SX" }, {  &IFM_ETHER |  &IFM_10_STP, "10baseSTP" }, {  &IFM_ETHER |  &IFM_10_STP, "STP" }, {  &IFM_ETHER |  &IFM_10_STP, "10STP" }, {  &IFM_ETHER |  &IFM_10_STP, "10BASE-STP" }, {  &IFM_ETHER |  &IFM_10_FL, "10baseFL" }, {  &IFM_ETHER |  &IFM_10_FL, "FL" }, {  &IFM_ETHER |  &IFM_10_FL, "10FL" }, {  &IFM_ETHER |  &IFM_10_FL, "10BASE-FL" }, {  &IFM_ETHER |  &IFM_1000_LX, "1000baseLX" }, {  &IFM_ETHER |  &IFM_1000_LX, "1000LX" }, {  &IFM_ETHER |  &IFM_1000_LX, "1000BASE-LX" }, {  &IFM_ETHER |  &IFM_1000_CX, "1000baseCX" }, {  &IFM_ETHER |  &IFM_1000_CX, "1000CX" }, {  &IFM_ETHER |  &IFM_1000_CX, "1000BASE-CX" }, {  &IFM_ETHER |  &IFM_1000_BX10, "1000BASE-BX10" }, {  &IFM_ETHER |  &IFM_1000_KX, "1000BASE-KX" }, {  &IFM_ETHER |  &IFM_1000_KX, "1000baseKX" }, {  &IFM_ETHER |  &IFM_1000_T, "1000baseT" }, {  &IFM_ETHER |  &IFM_1000_T, "1000T" }, {  &IFM_ETHER |  &IFM_1000_T, "1000BASE-T" }, {  &IFM_ETHER |  &IFM_HPNA_1, "HomePNA1" }, {  &IFM_ETHER |  &IFM_HPNA_1, "HPNA1" }, {  &IFM_ETHER |  &IFM_2500_KX |  &IFM_FDX, "2500BASE-KX" }, {  &IFM_ETHER |  &IFM_2500_KX |  &IFM_FDX, "2500baseKX" }, {  &IFM_ETHER |  &IFM_2500_T |  &IFM_FDX, "2.5GBASE-T" }, {  &IFM_ETHER |  &IFM_2500_T |  &IFM_FDX, "2500baseT" }, {  &IFM_ETHER |  &IFM_5000_T |  &IFM_FDX, "5GBASE-T" }, {  &IFM_ETHER |  &IFM_5000_T |  &IFM_FDX, "5GbaseT" }, {  &IFM_ETHER |  &IFM_10G_LR |  &IFM_FDX, "10GbaseLR" }, {  &IFM_ETHER |  &IFM_10G_LR |  &IFM_FDX, "10GLR" }, {  &IFM_ETHER |  &IFM_10G_LR |  &IFM_FDX, "10GBASE-LR" }, {  &IFM_ETHER |  &IFM_10G_SR |  &IFM_FDX, "10GbaseSR" }, {  &IFM_ETHER |  &IFM_10G_SR |  &IFM_FDX, "10GSR" }, {  &IFM_ETHER |  &IFM_10G_SR |  &IFM_FDX, "10GBASE-SR" }, {  &IFM_ETHER |  &IFM_10G_LRM |  &IFM_FDX, "10Gbase-LRM" }, {  &IFM_ETHER |  &IFM_10G_TWINAX |  &IFM_FDX, "10Gbase-Twinax" }, {  &IFM_ETHER |  &IFM_10G_TWINAX_LONG |  &IFM_FDX, "10Gbase-Twinax-Long" }, {  &IFM_ETHER |  &IFM_10G_T |  &IFM_FDX, "10Gbase-T" }, {  &IFM_ETHER |  &IFM_10G_CX4 |  &IFM_FDX, "10GbaseCX4" }, {  &IFM_ETHER |  &IFM_10G_CX4 |  &IFM_FDX, "10GCX4" }, {  &IFM_ETHER |  &IFM_10G_CX4 |  &IFM_FDX, "10GBASE-CX4" }, {  &IFM_ETHER |  &IFM_2500_SX |  &IFM_FDX, "2500baseSX" }, {  &IFM_ETHER |  &IFM_2500_SX |  &IFM_FDX, "2500SX" }, {  &IFM_TOKEN |  &IFM_TOK_STP4, "DB9/4Mbit" }, {  &IFM_TOKEN |  &IFM_TOK_STP4, "4STP" }, {  &IFM_TOKEN |  &IFM_TOK_STP16, "DB9/16Mbit" }, {  &IFM_TOKEN |  &IFM_TOK_STP16, "16STP" }, {  &IFM_TOKEN |  &IFM_TOK_UTP4, "UTP/4Mbit" }, {  &IFM_TOKEN |  &IFM_TOK_UTP4, "4UTP" }, {  &IFM_TOKEN |  &IFM_TOK_UTP16, "UTP/16Mbit" }, {  &IFM_TOKEN |  &IFM_TOK_UTP16, "16UTP" }, {  &IFM_FDDI |  &IFM_FDDI_SMF, "Single-mode" }, {  &IFM_FDDI |  &IFM_FDDI_SMF, "SMF" }, {  &IFM_FDDI |  &IFM_FDDI_MMF, "Multi-mode" }, {  &IFM_FDDI |  &IFM_FDDI_MMF, "MMF" }, {  &IFM_FDDI |  &IFM_FDDI_UTP, "UTP" }, {  &IFM_FDDI |  &IFM_FDDI_UTP, "CDDI" }, {  &IFM_ETHER |  &IFM_10_T |  &IFM_FDX, "10baseT-FDX" }, {  &IFM_ETHER |  &IFM_10_T |  &IFM_FDX, "10BASE-T-FDX" }, {  &IFM_ETHER |  &IFM_100_TX |  &IFM_FDX, "100baseTX-FDX" }, {  &IFM_ETHER |  &IFM_100_TX |  &IFM_FDX, "100BASE-TX-FDX" }, {  &IFM_ETHER |  &IFM_1000_T |  &IFM_FDX, "1000baseT-FDX" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_FH1, "FH1" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_FH2, "FH2" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS1, "DS1" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS2, "DS2" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS5, "DS5" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS11, "DS11" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS22, "DS22" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM6, "OFDM6" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM9, "OFDM9" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM12, "OFDM12" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM18, "OFDM18" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM24, "OFDM24" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM36, "OFDM36" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM48, "OFDM48" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM54, "OFDM54" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM72, "OFDM72" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS354k, "DS/354Kbps" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS512k, "DS/512Kbps" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM3, "OFDM/3Mbps" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM4, "OFDM/4.5Mbps" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM27, "OFDM/27Mbps" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_DESCRIPTIONS);
    eval 'sub IFM_MODE_DESCRIPTIONS () {{ {  &IFM_AUTO, "autoselect" }, {  &IFM_AUTO, "auto" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_11A, "11a" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_11B, "11b" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_11G, "11g" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_FH, "fh" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_11NA, "11na" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_11NG, "11ng" }, { 0,  &NULL }, };}' unless defined(&IFM_MODE_DESCRIPTIONS);
    eval 'sub IFM_OPTION_DESCRIPTIONS () {{ {  &IFM_FDX, "full-duplex" }, {  &IFM_FDX, "fdx" }, {  &IFM_HDX, "half-duplex" }, {  &IFM_HDX, "hdx" }, {  &IFM_FLOW, "flowcontrol" }, {  &IFM_FLOW, "flow" }, {  &IFM_FLAG0, "flag0" }, {  &IFM_FLAG1, "flag1" }, {  &IFM_FLAG2, "flag2" }, {  &IFM_LOOP, "loopback" }, {  &IFM_LOOP, "hw-loopback"}, {  &IFM_LOOP, "loop" }, {  &IFM_ETHER |  &IFM_ETH_MASTER, "master" }, {  &IFM_ETHER |  &IFM_ETH_RXPAUSE, "rxpause" }, {  &IFM_ETHER |  &IFM_ETH_TXPAUSE, "txpause" }, {  &IFM_TOKEN |  &IFM_TOK_ETR, "EarlyTokenRelease" }, {  &IFM_TOKEN |  &IFM_TOK_ETR, "ETR" }, {  &IFM_TOKEN |  &IFM_TOK_SRCRT, "SourceRouting" }, {  &IFM_TOKEN |  &IFM_TOK_SRCRT, "SRCRT" }, {  &IFM_TOKEN |  &IFM_TOK_ALLR, "AllRoutes" }, {  &IFM_TOKEN |  &IFM_TOK_ALLR, "ALLR" }, {  &IFM_FDDI |  &IFM_FDDI_DA, "dual-attach" }, {  &IFM_FDDI |  &IFM_FDDI_DA, "das" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_ADHOC, "adhoc" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_HOSTAP, "hostap" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_MONITOR,"monitor" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_TURBO, "turbo" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_IBSS, "ibss" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_WDS, "wds" }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_MBSS, "mesh" }, { 0,  &NULL }, };}' unless defined(&IFM_OPTION_DESCRIPTIONS);
    eval 'sub IFM_BAUDRATE_DESCRIPTIONS () {{ {  &IFM_ETHER |  &IFM_10_T,  &IF_Mbps(10) }, {  &IFM_ETHER |  &IFM_10_2,  &IF_Mbps(10) }, {  &IFM_ETHER |  &IFM_10_5,  &IF_Mbps(10) }, {  &IFM_ETHER |  &IFM_100_TX,  &IF_Mbps(100) }, {  &IFM_ETHER |  &IFM_100_FX,  &IF_Mbps(100) }, {  &IFM_ETHER |  &IFM_100_T4,  &IF_Mbps(100) }, {  &IFM_ETHER |  &IFM_100_VG,  &IF_Mbps(100) }, {  &IFM_ETHER |  &IFM_100_T2,  &IF_Mbps(100) }, {  &IFM_ETHER |  &IFM_1000_SX,  &IF_Mbps(1000) }, {  &IFM_ETHER |  &IFM_10_STP,  &IF_Mbps(10) }, {  &IFM_ETHER |  &IFM_10_FL,  &IF_Mbps(10) }, {  &IFM_ETHER |  &IFM_1000_LX,  &IF_Mbps(1000) }, {  &IFM_ETHER |  &IFM_1000_CX,  &IF_Mbps(1000) }, {  &IFM_ETHER |  &IFM_1000_T,  &IF_Mbps(1000) }, {  &IFM_ETHER |  &IFM_HPNA_1,  &IF_Mbps(1) }, {  &IFM_ETHER |  &IFM_10G_LR,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_10G_SR,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_10G_CX4,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_2500_SX,  &IF_Mbps(2500) }, {  &IFM_ETHER |  &IFM_1000_BX10,  &IF_Mbps(1000) }, {  &IFM_ETHER |  &IFM_10G_TWINAX,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_10G_TWINAX_LONG,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_10G_LRM,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_10G_T,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_1000_KX,  &IF_Mbps(1000) }, {  &IFM_ETHER |  &IFM_2500_KX,  &IF_Mbps(2500) }, {  &IFM_ETHER |  &IFM_2500_T,  &IF_Mbps(2500) }, {  &IFM_ETHER |  &IFM_5000_T,  &IF_Mbps(5000) }, {  &IFM_TOKEN |  &IFM_TOK_STP4,  &IF_Mbps(4) }, {  &IFM_TOKEN |  &IFM_TOK_STP16,  &IF_Mbps(16) }, {  &IFM_TOKEN |  &IFM_TOK_UTP4,  &IF_Mbps(4) }, {  &IFM_TOKEN |  &IFM_TOK_UTP16,  &IF_Mbps(16) }, {  &IFM_FDDI |  &IFM_FDDI_SMF,  &IF_Mbps(100) }, {  &IFM_FDDI |  &IFM_FDDI_MMF,  &IF_Mbps(100) }, {  &IFM_FDDI |  &IFM_FDDI_UTP,  &IF_Mbps(100) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_FH1,  &IF_Mbps(1) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_FH2,  &IF_Mbps(2) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS2,  &IF_Mbps(2) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS5,  &IF_Kbps(5500) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS11,  &IF_Mbps(11) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS1,  &IF_Mbps(1) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS22,  &IF_Mbps(22) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM6,  &IF_Mbps(6) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM9,  &IF_Mbps(9) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM12,  &IF_Mbps(12) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM18,  &IF_Mbps(18) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM24,  &IF_Mbps(24) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM36,  &IF_Mbps(36) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM48,  &IF_Mbps(48) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM54,  &IF_Mbps(54) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM72,  &IF_Mbps(72) }, { 0, 0}, };}' unless defined(&IFM_BAUDRATE_DESCRIPTIONS);
    eval 'sub IFM_STATUS_DESC {
        my($ifms, $bit) = @_;
	    eval q(($ifms)-> $ifms_string[(($ifms)-> &ifms_bit & ($bit)) ? 1: 0]);
    }' unless defined(&IFM_STATUS_DESC);
    eval 'sub IFM_STATUS_DESCRIPTIONS () {{ {  &IFM_GENERIC,  &IFM_AVALID,  &IFM_ACTIVE, { "no network", "active" } }, {  &IFM_ETHER,  &IFM_AVALID,  &IFM_ACTIVE, { "no carrier", "active" } }, {  &IFM_FDDI,  &IFM_AVALID,  &IFM_ACTIVE, { "no ring", "inserted" } }, {  &IFM_TOKEN,  &IFM_AVALID,  &IFM_ACTIVE, { "no ring", "inserted" } }, {  &IFM_IEEE80211,  &IFM_AVALID,  &IFM_ACTIVE, { "no network", "active" } }, {  &IFM_CARP,  &IFM_AVALID,  &IFM_ACTIVE, { "backup", "master" } }, { 0, 0, 0, {  &NULL,  &NULL } }, };}' unless defined(&IFM_STATUS_DESCRIPTIONS);
    if(defined(&_KERNEL)) {
    } else {
    }
}
1;
