require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__SCTP_UIO_H__)) {
    eval 'sub __SCTP_UIO_H__ () {1;}' unless defined(&__SCTP_UIO_H__);
    require 'sys/types.ph';
    require 'sys/socket.ph';
    eval 'sub SCTP_INIT () {0x1;}' unless defined(&SCTP_INIT);
    eval 'sub SCTP_SNDRCV () {0x2;}' unless defined(&SCTP_SNDRCV);
    eval 'sub MSG_SENDALL () {0x200;}' unless defined(&MSG_SENDALL);
    eval 'sub MSG_PR_SCTP_TTL () {0x400;}' unless defined(&MSG_PR_SCTP_TTL);
    eval 'sub MSG_PR_SCTP_BUF () {0x800;}' unless defined(&MSG_PR_SCTP_BUF);
    unless(defined(&MSG_EOF)) {
	eval 'sub MSG_EOF () {0x1000;}' unless defined(&MSG_EOF);
    }
    eval 'sub MSG_UNORDERED () {0x2000;}' unless defined(&MSG_UNORDERED);
    eval 'sub MSG_ADDR_OVER () {0x4000;}' unless defined(&MSG_ADDR_OVER);
    eval 'sub MSG_ABORT () {0x8000;}' unless defined(&MSG_ABORT);
    eval 'sub SCTP_COMM_UP () {0x1;}' unless defined(&SCTP_COMM_UP);
    eval 'sub SCTP_COMM_LOST () {0x2;}' unless defined(&SCTP_COMM_LOST);
    eval 'sub SCTP_RESTART () {0x3;}' unless defined(&SCTP_RESTART);
    eval 'sub SCTP_SHUTDOWN_COMP () {0x4;}' unless defined(&SCTP_SHUTDOWN_COMP);
    eval 'sub SCTP_CANT_STR_ASSOC () {0x5;}' unless defined(&SCTP_CANT_STR_ASSOC);
    eval 'sub SCTP_ADDR_AVAILABLE () {0x1;}' unless defined(&SCTP_ADDR_AVAILABLE);
    eval 'sub SCTP_ADDR_UNREACHABLE () {0x2;}' unless defined(&SCTP_ADDR_UNREACHABLE);
    eval 'sub SCTP_ADDR_REMOVED () {0x3;}' unless defined(&SCTP_ADDR_REMOVED);
    eval 'sub SCTP_ADDR_ADDED () {0x4;}' unless defined(&SCTP_ADDR_ADDED);
    eval 'sub SCTP_ADDR_MADE_PRIM () {0x5;}' unless defined(&SCTP_ADDR_MADE_PRIM);
    eval 'sub SCTP_ADDR_CONFIRMED () {0x6;}' unless defined(&SCTP_ADDR_CONFIRMED);
    if(defined(&SCTP_ACTIVE)) {
	undef(&SCTP_ACTIVE) if defined(&SCTP_ACTIVE);
    }
    eval 'sub SCTP_ACTIVE () {0x1;}' unless defined(&SCTP_ACTIVE);
    if(defined(&SCTP_INACTIVE)) {
	undef(&SCTP_INACTIVE) if defined(&SCTP_INACTIVE);
    }
    eval 'sub SCTP_INACTIVE () {0x2;}' unless defined(&SCTP_INACTIVE);
    if(defined(&SCTP_UNCONFIRMED)) {
	undef(&SCTP_UNCONFIRMED) if defined(&SCTP_UNCONFIRMED);
    }
    eval 'sub SCTP_UNCONFIRMED () {0x200;}' unless defined(&SCTP_UNCONFIRMED);
    if(defined(&SCTP_NOHEARTBEAT)) {
	undef(&SCTP_NOHEARTBEAT) if defined(&SCTP_NOHEARTBEAT);
    }
    eval 'sub SCTP_NOHEARTBEAT () {0x40;}' unless defined(&SCTP_NOHEARTBEAT);
    eval 'sub SCTP_DATA_UNSENT () {0x1;}' unless defined(&SCTP_DATA_UNSENT);
    eval 'sub SCTP_DATA_SENT () {0x2;}' unless defined(&SCTP_DATA_SENT);
    eval 'sub SCTP_PARTIAL_DELIVERY_ABORTED () {0x1;}' unless defined(&SCTP_PARTIAL_DELIVERY_ABORTED);
    eval 'sub SCTP_STRRESET_INBOUND_STR () {0x1;}' unless defined(&SCTP_STRRESET_INBOUND_STR);
    eval 'sub SCTP_STRRESET_OUTBOUND_STR () {0x2;}' unless defined(&SCTP_STRRESET_OUTBOUND_STR);
    eval 'sub SCTP_STRRESET_ALL_STREAMS () {0x4;}' unless defined(&SCTP_STRRESET_ALL_STREAMS);
    eval 'sub SCTP_STRRESET_STREAM_LIST () {0x8;}' unless defined(&SCTP_STRRESET_STREAM_LIST);
    eval 'sub MAX_ASOC_IDS_RET () {255;}' unless defined(&MAX_ASOC_IDS_RET);
    eval 'sub SCTP_ASSOC_CHANGE () {0x1;}' unless defined(&SCTP_ASSOC_CHANGE);
    eval 'sub SCTP_PEER_ADDR_CHANGE () {0x2;}' unless defined(&SCTP_PEER_ADDR_CHANGE);
    eval 'sub SCTP_REMOTE_ERROR () {0x3;}' unless defined(&SCTP_REMOTE_ERROR);
    eval 'sub SCTP_SEND_FAILED () {0x4;}' unless defined(&SCTP_SEND_FAILED);
    eval 'sub SCTP_SHUTDOWN_EVENT () {0x5;}' unless defined(&SCTP_SHUTDOWN_EVENT);
    eval 'sub SCTP_ADAPTION_INDICATION () {0x6;}' unless defined(&SCTP_ADAPTION_INDICATION);
    eval 'sub SCTP_PARTIAL_DELIVERY_EVENT () {0x7;}' unless defined(&SCTP_PARTIAL_DELIVERY_EVENT);
    eval 'sub SCTP_STREAM_RESET_EVENT () {0x8;}' unless defined(&SCTP_STREAM_RESET_EVENT);
    eval 'sub SCTP_ISSUE_HB () {0xffffffff;}' unless defined(&SCTP_ISSUE_HB);
    eval 'sub SCTP_NO_HB () {0x;}' unless defined(&SCTP_NO_HB);
    eval 'sub SCTP_MAX_EXPLICT_STR_RESET () {1000;}' unless defined(&SCTP_MAX_EXPLICT_STR_RESET);
    eval 'sub SCTP_RESET_LOCAL_RECV () {0x1;}' unless defined(&SCTP_RESET_LOCAL_RECV);
    eval 'sub SCTP_RESET_LOCAL_SEND () {0x2;}' unless defined(&SCTP_RESET_LOCAL_SEND);
    eval 'sub SCTP_RESET_BOTH () {0x3;}' unless defined(&SCTP_RESET_BOTH);
    if(!defined(&_KERNEL)) {
    }
}
1;
