require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&HEADER_HMAC_H)) {
    eval 'sub HEADER_HMAC_H () {1;}' unless defined(&HEADER_HMAC_H);
    require 'openssl/opensslconf.ph';
    if(defined(&OPENSSL_NO_HMAC)) {
	die("HMAC\ is\ disabled\.");
    }
    require 'openssl/evp.ph';
    eval 'sub HMAC_MAX_MD_CBLOCK () {128;}' unless defined(&HMAC_MAX_MD_CBLOCK);
    if(defined(&__cplusplus)) {
    }
    eval 'sub HMAC_size {
        my($e) = @_;
	    eval q(( &EVP_MD_size(($e)-> &md)));
    }' unless defined(&HMAC_size);
    eval 'sub HMAC_cleanup {
        my($ctx) = @_;
	    eval q( &HMAC_CTX_cleanup($ctx));
    }' unless defined(&HMAC_cleanup);
    if((defined(&OPENSSL_API_COMPAT) ? &OPENSSL_API_COMPAT : undef) >= 0x10100000) {
	eval 'sub HMAC_CTX () {
	    eval q(* &HMAC_CTX_new( &void) {  &HMAC_CTX * &ctx =  &calloc(1, $sizeof{ &ctx});  &if ( &ctx ==  &NULL)  &NULL;  &HMAC_CTX_init( &ctx);  &ctx; });
	}' unless defined(&HMAC_CTX);
	eval 'sub HMAC_CTX_free {
	    my($ctx) = @_;
    	    eval q({  &if ($ctx ==  &NULL) ;  &HMAC_CTX_cleanup($ctx);  &free($ctx); });
	}' unless defined(&HMAC_CTX_free);
	eval 'sub HMAC_CTX_reset {
	    my($ctx) = @_;
    	    eval q({  &HMAC_CTX_cleanup($ctx);  &HMAC_CTX_init($ctx); });
	}' unless defined(&HMAC_CTX_reset);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
